\def\RCSdate{$Date: 2004-08-14 11:47:22 $}
\def\RCSrevision{$Revision: 1.1.1.1 $}
{%
  \def\stripone $#1${\def\partone{#1}}
  \def\striptwo Date: #1\stop{\gdef\filedate{#1}\gdef\docdate{#1}}
  \expandafter\stripone\RCSdate
  \expandafter\striptwo\partone\stop
}%
{%
  \def\stripone $#1${\def\partone{#1}}
  \def\striptwo Revision: #1\stop{\gdef\fileversion{#1}}
  \expandafter\stripone\RCSrevision
  \expandafter\striptwo\partone\stop
}%

\NeedsTeXFormat{LaTeX2e}
\ProvidesClass{mwstrechnung}
\typeout{}
\typeout{%
  -----------------------------------------------------}
\typeout{%
  Rechnung in Tabellenform mit automatischer Berechnung}
\typeout{%
  mit grau-unterlegter Tabellen|berschrift}
\typeout{%
  Benutzt EC-Fonts!}
\typeout{%
  Version \fileversion}
\typeout{%
  Datum: \filedate}
\typeout{%
  -----------------------------------------------------}
\typeout{}

\LoadClass[12pt, a4paper, german]{dinbrief}

%\RequirePackage{german}
%\RequirePackage{isolatin1}
\RequirePackage{graphicx}
\RequirePackage{ifthen}
\RequirePackage{epsfig}
%\RequirePackage[T1]{fontenc}
\RequirePackage{calc}
\RequirePackage{sepnum}
\RequirePackage{colortbl}
\RequirePackage{color}

\newlength{\Ladr}
\newlength{\Ltel}
\newlength{\Lban}
\newcounter{position}
\newcounter{steuersatz} \setcounter{steuersatz}{19}
\newcounter{nettopf}  % Nettopreis in Pfennigen
\newcounter{steuerpf} % Steuer in Pfennigen
\newcounter{bruttopf} % Bruttopreis in Pfennigen
\newcounter{mark}
\newcounter{adihlp}
\newcounter{pfennig}
\setcounter{nettopf}{0}

\DeclareOption*{\PassOptionsToClass{\CurrentOption}{dinbrief}}
\ProcessOptions*

\settowidth{\Ladr}{B.-Asendorpf-Straße 46}
\settowidth{\Ltel}{E-mail: adrian@loris.tvXXXX}
\settowidth{\Lban}{Sparkasse Mittelth\"{u}ringen}

\newcommand{\m@wst}{% Mehrwertsteuer von nettopf berechnen
  \setcounter{steuerpf}{\value{nettopf} * \value{steuersatz}}
  \setcounter{steuerpf}{\value{steuerpf} * 100}
  \setcounter{adihlp}{100 + \value{steuersatz}}
  \setcounter{steuerpf}{\value{steuerpf} / \value{adihlp}}
  \addtocounter{steuerpf}{50} % zum runden
  \setcounter{steuerpf}{\value{steuerpf} / 100} % letzten beiden Stellen
                                                % streichen
  }

\newcommand{\steuersatz}[1]{%
  \setcounter{steuersatz}{#1}
  }

\newcommand{\b@rutto}{%
  \setcounter{bruttopf}{\value{nettopf} + \value{steuerpf}}}

\newcommand{\b@etrag}[1]{% gibt den Pfennig-Betrag in Mark und Pfennig aus
  \setcounter{mark}{\value{#1} / 100}
  \setcounter{pfennig}{\value{#1} - \value{mark} * 100}
  \sepnumform{,}{.}{}{mark},\relax % Mark-Betrag mit Komma und Punkten
                                   % ausgeben 
  \ifthenelse{\value{pfennig} < 10}{0}{}\relax\thepfennig\,EUR
  }


\newcommand{\Rechnung}[1]{%
  \subject{{\large \textbf{Rechnungs-Nr: #1}}}
  }

\newcommand{\Auftrag}[1]{%
  \textbf{Ihr Auftrag:} 
    \parbox[t]{10cm}{%
      #1
      }
    \vspace{1cm}}

\newcommand{\Auftraggeber}[1]{%
  \opening{\textbf{Auftraggeber:}
    \parbox[t]{10cm}{%
      #1
      }
    \vspace{1cm}}
  }

\newcommand{\Arbeit}[2]{%
  \ifthenelse{\equal{#1}{}}{ & & \\}{%
    \stepcounter{position} 
    \arabic{position} & #1 & 
    \setcounter{pfennig}{#2}
    \addtocounter{nettopf}{#2}
    \m@wst % Mehrwertsteuer berechnen
    \b@rutto % Bruttobetrag berechnen
    \b@etrag{pfennig}\\
    }
  }

\newenvironment{Tabelle}{%
  \begin{tabular}{|l|p{11cm}|r|}\hline 
    \rowcolor[gray]{.8}
    \textbf{Pos.} & \textbf{ausgef\"{u}hrte Arbeit} & \textbf{Netto-Preis}
    \\\hline\hline
    }{%
    \hline\hline
    \multicolumn{2}{|l|}{Bruttosumme:} & \b@etrag{nettopf}\\
    \multicolumn{2}{|l|}{inkl. Mehrwertsteuer (\thesteuersatz\%):} &
	\b@etrag{steuerpf}\\ 
    \multicolumn{2}{|l|}{\textbf{Gesamtsumme:}} & 
    \textbf{\b@etrag{nettopf}}\\\hline 
  \end{tabular}
  }

\newenvironment{rletter}[1]{%
  \bottomtext{\Foot}
  \setbottomtexttop{265mm}
  \begin{letter}{#1}
%\signature{Betrag dankend erhalten\\
%Modern Electronics}
%    }{%
%\closing{Betrag dankend erhalten}
%	\closing{zahlbar innerhalb 14 Tagen ohne Abzug\\
%[\medskipamount]
%{\color{magenta}Beachten Sie: Wir führen jede Art an Büroartikel sowie ein
%reichhaltiges CD-Sortiment. Desweiteren
%sind wir für Sie in Computerfragen da.}}
}{%
\closing{{\color{blue}Information: Wir
                          bieten Spezial- und Netzwerkl\"{o}sungen sowie
                          UNIX-Implementierungen. Desweiteren sind wir
                          f\"{u}r Sie in allen Computerfragen da.}\\ Vielen
                          Dank f\"{u}r Ihren Auftrag.} 

  \end{letter}
  }

\newcommand{\Foot}{%
  \rule{\textwidth}{.6pt}
\parbox[b]{\Ladr}{
    Adrian Knoth\\
	Mystreet 4711\\
% \\
   99438 Bad Berka
    }
  \hfill
  \parbox[b]{\Ltel}{
Fax : +49 12345 909\\
Steuer-Nr.: DE / 12345\\
E-Mail: adrian@loris.tv
    }
  \hfill
  \parbox[b]{\Lban}{%
    Sparkasse Mittelth\"{u}ringen\\
    Konto: 1234567890\\
    BLZ: 820 510 00
    }
  } 
     
\newcommand{\briefkopf}{%
  \hfill
%  \raisebox{-11.3mm}{
\raisebox{-8cm}{
    \parbox[t]{205pt}{
	%\psfig{file=logo.ps}	% give full path (/home/...) if necessary
      %logo.eps
     }
    }
  
}

\newcommand{\FS}{%
  \textsl{
    Loris Technology \& Vision$\cdot$
    Niederlassung Bad Berka}
  }
               

\backaddress{\FS}
\place{Bad Berka}
\phone{1234568}{555SHOE}
\address{\briefkopf}
