with generic_sql;
with Ustrings; use Ustrings;

--  with Ada.Text_IO; use Ada.Text_IO;
with Ada.Wide_Wide_Text_IO; use Ada.Wide_Wide_Text_IO;
with dispatcher; use dispatcher;
with Glib.Convert; use Glib.Convert;
with utf8; use utf8;


package body ab_latex is

   procedure Initialize --  does nothing
   is begin
      null;
   end Initialize;

   procedure create_file (rechnr : in String)
   is
      ergebnis : Pg.Result_Type;
      buffer : Ustring := hole_knr (rechnr);
      Datei : Ada.Wide_Wide_Text_IO.File_Type;
      buffer1, buffer2 : Ustring;

      query : Ustring := "select vorname,name,firma,strasse," &
            "plz,ort from kunden where kundennummer='" & buffer & "';";

   begin
      sql.do_query (To_String (query), ergebnis);
      Create (Datei, Out_File, "/tmp/" & rechnr & ".tex");
      Put (Datei, "\documentclass[a4paper,10pt]{mwstrechnung} " &
                  "\usepackage[utf8]{inputenc} " &
                  "\begin{document} \begin{rletter}{");

      Pg.Get (ergebnis, 0, 0, buffer); texstring (buffer);
      Pg.Get (ergebnis, 0, 1, buffer1); texstring (buffer1);
      utf8.Put_Line (Datei, buffer & " " & buffer1 & "\\");

      buffer2 := buffer & " " & buffer1;

      Pg.Get (ergebnis, 0, 2, buffer); texstring (buffer);
      if (buffer /= "") then
         Put_Line (Datei, buffer & "\\");
      end if;

      Pg.Get (ergebnis, 0, 3, buffer); texstring (buffer);
      Put_Line (Datei, buffer & "\\");
      Put_Line (Datei, "[\medskipamount]");

      Pg.Get (ergebnis, 0, 4, buffer); texstring (buffer);
      Pg.Get (ergebnis, 0, 5, buffer1); texstring (buffer);
      Put_Line (Datei, buffer & " " & buffer1 & "}");

      Pg.Forget (ergebnis);

      --  address-data written, go on with dates

      query := To_Ustring ("select datum,zahldatum from rechnung " &
                  "where rechnungsnummer='" & rechnr & "';");

      sql.do_query (To_String (query), ergebnis);

      Pg.Get (ergebnis, 0, 0, buffer);
      Put_Line (Datei, "\date{" & buffer & "}");

      Pg.Get (ergebnis, 0, 1, buffer1);
      Put_Line (Datei, "\signature{Zahlbar bis " & buffer1 &
                      " (Datum der Gutschrift gilt)}");

      Pg.Forget (ergebnis);

      --  dates written, go on with bill-#, followed by items
      Put_Line (Datei, To_Ustring ("\Rechnung{" & rechnr & "}"));

      Put_Line (Datei, "\Auftraggeber{" & buffer2 & "}");

      query := To_Ustring ("select menge,artikelname,menge*einzelpreis " &
                           "from rechnungsposten where rechnungsnummer='" &
                  rechnr & "' ORDER BY pnr;");

      Put_Line (Datei, "\begin{Tabelle}");

      sql.do_query (To_String (query), ergebnis);

      for I in 0 .. ergebnis.Tuples_Qt - 1 loop
         Pg.Get (ergebnis, I, 0, buffer);
         Pg.Get (ergebnis, I, 1, buffer1); texstring (buffer1);
         Pg.Get (ergebnis, I, 2, buffer2);
         buffer2 := To_Ustring (Integer'Image (Integer (
                                   Float'Value (To_String
                                           (buffer2)) * 100.0)));
         Put_Line (Datei, "\Arbeit{" & buffer & "x " &
                       buffer1 & "}{" & buffer2 & "}");
      end loop;

      Put_Line (Datei, "\end{Tabelle}" &
                       --   " \closing{{\color{blue}Information: Wir" &
                       --   " bieten Spezial- und Netzwerklösungen sowie" &
                       --   " UNIX-Implementierungen. Desweiteren sind wir" &
                       --   " für Sie in allen Computerfragen da.}\\ Vielen" &
                       --   " Dank für Ihren Auftrag.}
                          "\end{rletter}" &
                          " \end{document} ");

      Close (Datei);
   end create_file;


   procedure texstring (ausdruck : in out Ustring)
   is
      tmp : String := To_String (ausdruck);
      hs : Ustring := To_Ustring ("");
   begin
      ausdruck := To_Ustring ("");
      for I in tmp'Range loop
         case tmp (I) is
            when '&' => hs := To_Ustring ("\&");
            when '%' => hs := To_Ustring ("\%");
            when others => hs := To_Ustring (tmp (I) & "");
         end case;
         ausdruck := ausdruck & hs;
      end loop;
   end texstring;

end ab_latex;

