with System; use System;
with Glib; use Glib;
with Gdk.Event; use Gdk.Event;
with Gdk.Types; use Gdk.Types;
with Gtk.Accel_Group; use Gtk.Accel_Group;
with Gtk.Object; use Gtk.Object;
with Gtk.Enums; use Gtk.Enums;
with Gtk.Style; use Gtk.Style;
with Gtk.Widget; use Gtk.Widget;
with Gtk.Menu_Item;

with Gtk.Main;

with sql; use sql;

with Window1_Pkg; use Window1_Pkg;
with Dialog1_Pkg; use Dialog1_Pkg;

with Ada.Text_IO; use Ada.Text_IO;

with Ustrings; use Ustrings;

with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;
with utf8;

with Gtkada.Types; use Gtkada.Types;

with Gdk.Font; with Gdk.Color;
with Gtk.Check_Button;

with dispatcher;

with Glib, Glib.Glist; use Glib;

--  with Gtk.Notebook;

package body Window1_Pkg.Callbacks is

   use Gtk.Arguments;


   --------------------
   -- call_statusbar --
   --------------------

   procedure call_statusbar (text : in String)
   is
      my_id : Context_Id := Get_Context_Id (Window1.Statusbar1, "Hallo");
      message : Message_Id;
   begin
      message := Push (Window1.Statusbar1, my_id, text);
   end call_statusbar;

   --------------------------
   -- On_Beenden1_Activate --
   --------------------------

   procedure On_Beenden1_Activate
     (Object : access Gtk_Menu_Item_Record'Class)
   is

   begin
      sql.Pg.Disconnect;       --  terminate SQL-Connection
      Gtk.Main.Main_Quit;
   end On_Beenden1_Activate;

   --  wrapper for window-destroy  --
   procedure on_window1_destroy
     (Object : access Gtk_Window_Record'Class)
   is
   begin
      Gtk.Menu_Item.Activate (Window1.Beenden1);
   end on_window1_destroy;

   -------------------------------------
   -- On_Really_Print_Always_Activate --
   -------------------------------------

   procedure On_Really_Print_Always_Activate
     (Object : access Gtk_Check_Menu_Item_Record'Class)
   is
   begin
      if (Get_Active (Window1.Always1)) then
         call_statusbar (" Always print the bill on paper");
      else
         call_statusbar (" Only generate tex-File. Never print on paper");
      end if;
   end On_Really_Print_Always_Activate;

   ------------------------
   -- On_Email1_Activate --
   ------------------------

   procedure On_Email1_Activate
     (Object : access Gtk_Menu_Item_Record'Class)
   is
   begin
      null;
   end On_Email1_Activate;

   -----------------------
   -- On_News1_Activate --
   -----------------------

   procedure On_News1_Activate
     (Object : access Gtk_Menu_Item_Record'Class)
   is
   begin
      null;
   end On_News1_Activate;

   ----------------------
   -- On_Web1_Activate --
   ----------------------

   procedure On_Web1_Activate
     (Object : access Gtk_Menu_Item_Record'Class)
   is
   begin
      null;
   end On_Web1_Activate;

   ------------------------
   -- On_Hilfe1_Activate --
   ------------------------

   procedure On_Hilfe1_Activate
     (Object : access Gtk_Menu_Item_Record'Class)
   is
   begin
      null;
   end On_Hilfe1_Activate;

   -----------------------
   -- On_About_Activate --
   -----------------------

   procedure On_About_Activate
     (Object : access Gtk_Menu_Item_Record'Class)
   is
   begin
      Gtk_New (Dialog1);
      Show_All (Dialog1);
   end On_About_Activate;

   -----------------------
   -- On_Toggle_Printer --
   -----------------------

   procedure On_Toggle_Printer
     (Object : access Gtk_Widget_Record'Class;
      Params : Gtk.Arguments.Gtk_Args)
   is
   begin
      null;
   end On_Toggle_Printer;

   -------------------------
   -- On_Button10_Clicked --
   -------------------------

   procedure On_Button10_Clicked
     (Object : access Gtk_Button_Record'Class)
   is
      ergebnis : Pg.Result_Type;           -- SQL-Result
      buffer : Ustring;
      vorname : constant String := Get_Text (Window1.Entry13);
      name : constant String := Get_Text (Window1.Entry14);
      firma : constant String := Get_Text (Window1.Entry15);
   begin
      if (vorname /= "") or (name /= "") or (firma /= "") then
         sql.do_query ("insert into kunden" &
         "(vorname,name,firma,strasse,plz,ort,tel,fax,funk,email,business)" &
         "values('" &
         vorname &"','"&name &"','"&
         Get_Text (Window1.Entry15)&
         "','" & Get_Text (Window1.Entry16) &
         "','" & Get_Text (Window1.Entry17) &
         "','" & Get_Text (Window1.Entry18) &
         "','" & Get_Text (Window1.Entry19) &
         "','" & Get_Text (Window1.Entry20) &
         "','" & Get_Text (Window1.Entry21) &
         "','" & Get_Text (Window1.Entry22) &
         "','" & Boolean'Image (Get_Active (Window1.Checkbutton2)) &
         "');", ergebnis);

         sql.forget (ergebnis);

         sql.do_query ("select currval('kundenid')", ergebnis);
         Pg.Get (ergebnis, 0, 0, buffer);
         sql.forget (ergebnis);

         call_statusbar (" Kundennummer für " &
               vorname & " " & name & ": " & To_String (buffer));
      end if;
   end On_Button10_Clicked;

   -------------------------
   -- On_Button11_Clicked --
   -------------------------

   procedure On_Button11_Clicked
     (Object : access Gtk_Button_Record'Class)
   is
   begin
      Set_Text (Window1.Entry13, "");
      Set_Text (Window1.Entry14, "");
      Set_Text (Window1.Entry15, "");
      Set_Text (Window1.Entry16, "");
      Set_Text (Window1.Entry17, "");
      Set_Text (Window1.Entry18, "");
      Set_Text (Window1.Entry19, "");
      Set_Text (Window1.Entry20, "");
      Set_Text (Window1.Entry21, "");
      Set_Text (Window1.Entry22, "");
   end On_Button11_Clicked;

   -----------------
   -- Suche Kunde --
   -----------------

   function suche_kunde
     (kundennummer, vorname, nachname : in String; query : in Ustring)
     return Ustring
   is
      firstEntry : Boolean := True;
      query2 : Ustring := query;
   begin
      if (kundennummer /= "") then
         query2 := query2 & "kundennummer='" & kundennummer & "' ";
         firstEntry := False;
      end if;

      if (vorname /= "") then
         if (firstEntry = True) then
            query2 := query2 & "vorname='" & vorname & "' ";
            firstEntry := False;
         else
            query2 := query2 & "AND vorname='" & vorname & "' ";
         end if;
      end if;

      if (nachname /= "") then
         if (firstEntry = True) then
            query2 := query2 & "name='" & nachname & "' ";
            firstEntry := False;
         else
            query2 := query2 & "AND name='" & nachname & "' ";
         end if;
      end if;
      return query2;
   end suche_kunde;

   -----------------------
   -- Hole_Kundendaten --
   -----------------------

   procedure hole_kundendaten (kundennummer : in String) is

         query : constant String := "select * from kunden where " &
                                    "kundennummer=" & kundennummer;

         ergebnis : Pg.Result_Type;
         buffer : Ustring;

         das_array : constant array (Positive range <>) of Gtk_Entry :=
                     (Window1.Entry26, Window1.Entry27, Window1.Entry28,
                      Window1.Entry29, Window1.Entry30, Window1.Entry31,
                      Window1.Entry32, Window1.Entry33, Window1.Entry34,
                      Window1.Entry35, Window1.Entry36);

   begin
         sql.do_query (query, ergebnis);

         for I in das_array'Range loop
            sql.Pg.Get (ergebnis, 0, I - 1, buffer);
            Set_Text (das_array (I), To_String (buffer));
         end loop;

         sql.forget (ergebnis);

   end hole_kundendaten;
   ------------------------------
   -- On_Suchdenkunden_Clicked --
   ------------------------------

   procedure On_Suchdenkunden_Clicked
     (Object : access Gtk_Button_Record'Class)
   is

      query : Ustring := To_Unbounded_String ("select kundennummer from " &
                                              "kunden where ");
      kundennummer : constant String := Get_Text (Window1.Entry23);
      vorname : constant String := Get_Text (Window1.Entry24);
      nachname : constant String := Get_Text (Window1.Entry25);
      ergebnis : Pg.Result_Type;
      buffer : Ustring;

   begin
      if kundennummer = "" and vorname = "" and nachname = "" then
         call_statusbar (" Enter search-string");
      else
         query := suche_kunde (kundennummer, vorname, nachname, query);
         sql.do_query (To_String (query) & ";", ergebnis);
         sql.Pg.Get (ergebnis, 0, 0, buffer);
         Pg.Forget (ergebnis);

         if (buffer /= "") then
            hole_kundendaten (To_String (buffer));
            call_statusbar (" Kunde gefunden");
            Set_Page (Window1.Notebook2, -1);
         else
            call_statusbar (" Kunde nicht gefunden");
         end if;
      end if;
   end On_Suchdenkunden_Clicked;


   ----------------------------
   -- On_Mail_Client_Pressed --
   ----------------------------

   procedure On_Mail_Client_Pressed
     (Object : access Gtk_Button_Record'Class)
   is
      email : constant String := Get_Text (Window1.Entry36);
   begin
      if (email /= "") then
         dispatcher.send_email_to_client (email);
      else
         call_statusbar (" Client has no Email-address");
      end if;
   end On_Mail_Client_Pressed;

   -------------------------
   -- On_Modkunde_Clicked --
   -------------------------

   procedure On_Modkunde_Clicked
     (Object : access Gtk_Button_Record'Class)
   is
      ergebnis : Pg.Result_Type;
   begin
      sql.do_query ("update kunden " &
                    "set vorname='" &
                    Get_Text (Window1.Entry27) & "',name='" &
                    Get_Text (Window1.Entry28) & "',firma='" &
                    Get_Text (Window1.Entry29) & "',strasse='" &
                    Get_Text (Window1.Entry30) & "',plz='" &
                    Get_Text (Window1.Entry31) & "',ort='" &
                    Get_Text (Window1.Entry32) & "',tel='" &
                    Get_Text (Window1.Entry33) & "',fax='" &
                    Get_Text (Window1.Entry34) & "',funk='" &
                    Get_Text (Window1.Entry35) & "',email='" &
                    Get_Text (Window1.Entry36) & "' where kundennummer=" &
                    Get_Text (Window1.Entry26) & ";", ergebnis);
      sql.forget (ergebnis);
      call_statusbar (" Kunde geändert");
   end On_Modkunde_Clicked;

   ----------------------------
   -- On_Neurechnung_Clicked --
   ----------------------------

   procedure On_Neurechnung_Clicked
     (Object : access Gtk_Button_Record'Class)
   is
      ergebnis : Pg.Result_Type;
      query : Ustring := To_Ustring ("select kundennummer from kunden where ");
      kundennummer : constant String := Get_Text (Window1.Entry37);
      vorname : constant String := Get_Text (Window1.Entry38);
      nachname : constant String := Get_Text (Window1.Entry39);
      buffer : Ustring;

   begin
      query := suche_kunde (kundennummer, vorname, nachname, query);
      sql.do_query (To_String (query), ergebnis);
      sql.Pg.Get (ergebnis, 0, 0, buffer);
      Pg.Forget (ergebnis);

      if (buffer /= "") then

         query := "insert into rechnung (kundennummer) values('" & buffer &
                  "');";
         sql.do_query (To_String (query), ergebnis);
         Pg.Forget (ergebnis);

         query := To_Ustring ("select currval('rechnungsid')");
         sql.do_query (To_String (query), ergebnis);
         sql.Pg.Get (ergebnis, 0, 0, buffer);
         Pg.Forget (ergebnis);
         Set_Text (Window1.Entry42, To_String (buffer));
         call_statusbar (" Neue Rechnung angelegt");
         Next_Page (Window1.Notebook3);
      else
         call_statusbar (" Kunde nicht gefunden");
      end if;
   end On_Neurechnung_Clicked;

   -----------------------------
   -- On_Posten_Hinzu_Clicked --
   -----------------------------

   procedure On_Posten_Hinzu_Clicked
     (Object : access Gtk_Button_Record'Class)
   is
      menge : constant String := Get_Text (Window1.Entry45);
      artbez : constant String := Get_Text (Window1.Entry44);
      epreis : constant String := Get_Text (Window1.Entry43);
      rechnr : constant String := Get_Text (Window1.Entry42);

      ergebnis : Pg.Result_Type;
      buffer : Ustring;
      query : Ustring := To_Ustring ("insert into rechnungsposten " &
                                     "values(nextval('postennummer'),'") &
                                      rechnr & "','" & artbez & "','" &
                                      epreis & "','" & menge & "');";
   begin

      sql.do_query (To_String (query), ergebnis);
      Pg.Forget (ergebnis);
      call_statusbar (menge & " Artikel à " &
                      epreis & " in Rechnung " & rechnr & " hinzugefügt");
   end On_Posten_Hinzu_Clicked;

   --------------------------------
   -- On_Rechnung_Fertig_Clicked --
   --------------------------------

   procedure On_Rechnung_Fertig_Clicked
     (Object : access Gtk_Button_Record'Class)
   is
   begin
      Set_Text (Window1.Entry52, Get_Text (Window1.Entry42));
      Clicked (Window1.Button16);
      Clicked (Window1.Button19); --  Rechnungsdetails setzen
      Set_Page (Window1.Notebook3, 2);
   end On_Rechnung_Fertig_Clicked;


   -----------------------
   -- on_zeige_rechnung --
   -----------------------

   function on_zeige_rechnung return String
   is
      ergebnis : Pg.Result_Type;
      rechnr : constant String := Get_Text (Window1.Entry52);
      kundennr : Ustring := dispatcher.hole_knr (rechnr);
      buffer, buffer1, buffer2, buffer3, buffer4 : Ustring;

      query : Ustring := "select vorname,name,firma,strasse," &
                  "plz,ort from kunden where kundennummer='" & kundennr & "';";
      row : Gint;

   begin
      call_statusbar ("");
      sql.do_query (To_String (query), ergebnis);
      Pg.Get (ergebnis, 0, 0, buffer);
      Pg.Get (ergebnis, 0, 1, buffer2);
      Set_Text (Window1.Entry53, To_String (buffer & " " & buffer2));
      Pg.Get (ergebnis, 0, 2, buffer);
      Set_Text (Window1.Entry54, To_String (buffer));

      Pg.Get (ergebnis, 0, 3, buffer);
      Set_Text (Window1.Entry55, To_String (buffer));

      Pg.Get (ergebnis, 0, 4, buffer);
      Pg.Get (ergebnis, 0, 5, buffer2);

      Set_Text (Window1.Entry56, To_String (buffer & " " & buffer2));
      Set_Text (Window1.Entry56a, To_String (kundennr));
      Pg.Forget (ergebnis);

      --  fill the Clist

      query := To_Ustring ("select pnr,menge,artikelname,einzelpreis," &
                           "menge*einzelpreis" &
             " as gesamt from rechnungsposten where rechnungsnummer='" &
              rechnr & "' ORDER BY pnr;");

      sql.do_query (To_String (query), ergebnis);

      Freeze (Window1.Clist3);
      Gtk.Clist.Clear (Window1.Clist3);
      for I in 0 .. ergebnis.Tuples_Qt - 1 loop
         Pg.Get (ergebnis, I, 0, buffer);
         Pg.Get (ergebnis, I, 1, buffer1);
         Pg.Get (ergebnis, I, 2, buffer2);
         Pg.Get (ergebnis, I, 3, buffer3);
         Pg.Get (ergebnis, I, 4, buffer4);
         row := Gtk.Clist.Append (Window1.Clist3, To_String (buffer) +
                                  To_String (buffer1) + To_String (buffer2) +
                                  To_String (buffer3) + To_String (buffer4));

      end loop;
      Pg.Forget (ergebnis);

      Thaw (Window1.Clist3);

      query := To_Ustring ("select sum(einzelpreis*menge) as gesamt from " &
                 "rechnungsposten where rechnungsnummer='" & rechnr & "';");

      sql.do_query (To_String (query), ergebnis);

      Pg.Get (ergebnis, 0, 0, buffer);
      Set_Text (Window1.Entry57, To_String (buffer));
      Pg.Forget (ergebnis);

      return rechnr;
   end on_zeige_rechnung;


   -------------------------
   -- fill_details_widget --
   -------------------------

   procedure fill_details_widget (rechnr : in String)
   is
      ergebnis : Pg.Result_Type;
      delsuccess : Boolean;
      buffer : Ustring;
      query : Ustring := To_Ustring ("select datum,zahldatum," &
  "mitarbeiter,status,mahnungstyp,kommentar from rechnung " &
  "where rechnungsnummer='" & rechnr & "';");

   begin

      Set_Text (Window1.Entry58, rechnr);

      sql.do_query (To_String (query), ergebnis);

      Pg.Get (ergebnis, 0, 0, buffer);
      if (buffer /= "") then
         Set_Text (Window1.Entry59, To_String (buffer));
      else
         Set_Text (Window1.Entry59, dispatcher.datum (0));
      end if;

      Pg.Get (ergebnis, 0, 1, buffer);
      if (buffer /= "") then
         Set_Text (Window1.Entry60, To_String (buffer));
      else
         Set_Text (Window1.Entry60, dispatcher.datum (14));
      end if;

      Pg.Get (ergebnis, 0, 2, buffer);
      Set_Text (Window1.Entry61, To_String (buffer));

      Pg.Get (ergebnis, 0, 3, buffer);
      Set_Text (Window1.Entry62, To_String (buffer));

      Pg.Get (ergebnis, 0, 4, buffer);
      if buffer /= "t" then
         Set_Active (Window1.Checkbutton1, False);
      else
         Set_Active (Window1.Checkbutton1, True);
      end if;

      Pg.Get (ergebnis, 0, 5, buffer);

      Freeze (Window1.Text1);

      Set_Point (Window1.Text1, 0);
      delsuccess := Forward_Delete (Window1.Text1, Get_Length (Window1.Text1));

      Gtk.Text.Insert (Window1.Text1,
                Gdk.Font.Null_Font,
                Gdk.Color.Null_Color,
                Gdk.Color.Null_Color,
                To_String (buffer));

      Thaw (Window1.Text1);
      Pg.Forget (ergebnis);
   end fill_details_widget;

   -------------------------------
   -- On_Zeige_Rechnung_Clicked --
   -------------------------------

   procedure On_Zeige_Rechnung_Clicked
     (Object : access Gtk_Button_Record'Class)
   is
      rechnr : constant String := on_zeige_rechnung;
      ergebnis : Pg.Result_Type;

      query : constant String := "update rechnung set gesamtbetrag=(select " &
                        "sum(einzelpreis*menge) from rechnungsposten where " &
                 "rechnungsnummer='" & rechnr & "') where rechnungsnummer='" &
                  rechnr & "';";
   begin
      sql.do_query (query, ergebnis);
      Pg.Forget (ergebnis);
      fill_details_widget (rechnr);
   end On_Zeige_Rechnung_Clicked;

   --------------------------
   -- On_Clist3_Select_Row --
   --------------------------

   procedure On_Clist3_Select_Row
     (Object : access Gtk_Clist_Record'Class;
      Params : Gtk.Arguments.Gtk_Args)
   is
      Arg1 : Gint := To_Gint (Params, 1);
      Arg2 : Gint := To_Gint (Params, 2);
      Arg3 : Gdk_Event := To_Event (Params, 3);
   begin
   --  get P# and fill the widget with it
      Set_Text (Window1.Entry67, Get_Text (Window1.Clist3, Arg1, 0));
      Set_Text (Window1.Entry68, Get_Text (Window1.Clist3, Arg1, 1));
      Set_Text (Window1.Entry69, Get_Text (Window1.Clist3, Arg1, 2));
      Set_Text (Window1.Entry70, Get_Text (Window1.Clist3, Arg1, 3));
      call_statusbar (" Posten ausgewählt");
   end On_Clist3_Select_Row;

   ------------------------------
   -- On_Change_Posten_Clicked --
   ------------------------------

   procedure On_Change_Posten_Clicked
     (Object : access Gtk_Button_Record'Class)
   is
      pnr   : constant String := Get_Text (Window1.Entry67);

      query : constant String := "UPDATE rechnungsposten SET " & "menge='" &
                           Get_Text (Window1.Entry68) & "', artikelname='" &
                           Get_Text (Window1.Entry69) & "', einzelpreis='" &
                           Get_Text (Window1.Entry70) & "' WHERE pnr=" & pnr;

      ergebnis : Pg.Result_Type;
      rechnr : Ustring;

   begin
      sql.do_query (query, ergebnis);
      rechnr := To_Ustring (on_zeige_rechnung); --  redisplay the bill
      call_statusbar (" Posten " & pnr &  (" geändert"));
   end On_Change_Posten_Clicked;

   ------------------------------
   -- On_Delete_Posten_Clicked --
   ------------------------------

   procedure On_Delete_Posten_Clicked
     (Object : access Gtk_Button_Record'Class)
   is
      pnr : constant String := Get_Text (Window1.Entry67);
      query : constant String := "DELETE FROM rechnungsposten WHERE pnr=" &
                                  pnr;
      ergebnis : Pg.Result_Type;
      rechnr : Ustring;
   begin
      sql.do_query (query, ergebnis);
      rechnr := To_Ustring (on_zeige_rechnung);
      call_statusbar (" Posten " & pnr &  (" gelöscht"));
   end On_Delete_Posten_Clicked;

   ----------------------
   -- On_Print_Clicked --
   ----------------------

   procedure On_Print_Clicked
     (Object : access Gtk_Button_Record'Class)
   is
      rechnr : constant String := Get_Text (Window1.Entry52);
   begin
      if (rechnr /= "") then
         dispatcher.printbill (rechnr);
         call_statusbar (" File /tmp/" & rechnr & ".tex created");
         if (Get_Active (Window1.Always1)) then
            dispatcher.my_C_system ("cd /tmp && latex /tmp/" & rechnr &
                                 ".tex && dvips /tmp/" & rechnr & ".dvi &");
         end if;
      end if;
   end On_Print_Clicked;

   -------------------------------
   -- On_Setbilldetails_Clicked --
   -------------------------------

   procedure On_Setbilldetails_Clicked
     (Object : access Gtk_Button_Record'Class)
   is
      ergebnis : Pg.Result_Type;
      query : Ustring;

   begin
      query := To_Ustring ("update rechnung set datum='" &
                           Get_Text (Window1.Entry59) & "',zahldatum='" &
                           Get_Text (Window1.Entry60) & "',mitarbeiter='" &
                           Get_Text (Window1.Entry61) & "',status='" &
                           Get_Text (Window1.Entry62) & "',mahnungstyp='");

      if (Get_Active (Window1.Checkbutton1) = True) then
         query := query & "t',";
      else
         query := query & "f',";
      end if;

      query := query & "kommentar='" & Get_Chars (Window1.Text1) &
                "' where rechnungsnummer='" &
                Get_Text (Window1.Entry58) & "';";

      sql.do_query (To_String (query), ergebnis);
      Pg.Forget (ergebnis);
      call_statusbar (" Rechnungsdetails geändert");
   end On_Setbilldetails_Clicked;

   ---------------------------------
   -- On_Billdetailsreset_Clicked --
   ---------------------------------

   procedure On_Billdetailsreset_Clicked
     (Object : access Gtk_Button_Record'Class)
   is
      rechnr : constant String := Get_Text (Window1.Entry58);
   begin
      if (rechnr /= "") then
         fill_details_widget (rechnr);
         call_statusbar (" Ursprüngliche Werte angezeigt");
      end if;
   end On_Billdetailsreset_Clicked;

   --------------------
   -- On_Search_Bill --
   --------------------

   procedure On_Search_Bill
     (Object : access Gtk_Button_Record'Class)
   is
      knr : Ustring := To_Ustring (Get_Text (Window1.Entry63));
      vorname : constant String := Get_Text (Window1.Entry64);
      name : constant String := Get_Text (Window1.Entry65);
      query : Ustring := To_Ustring ("select kundennummer from kunden where ");
      ergebnis : Pg.Result_Type;
      buffer, buffer2, buffer3 : Ustring;
      no_result : Boolean := False;
      row : Gint;
   begin
      if (knr = "" and name = "" and vorname = "") then
         query := To_Ustring ("select rechnungsnummer,datum,kommentar" &
                                  " from rechnung order by rechnungsnummer;");
      else
         if (knr = "") then
            query := suche_kunde (To_String (knr), vorname, name, query);
            sql.do_query (To_String (query), ergebnis);

            if (ergebnis.Tuples_Qt = 0) then
               no_result := True;
            else
               Pg.Get (ergebnis, 0, 0, buffer);
               Pg.Forget (ergebnis);
               knr := buffer;
            end if;
         end if;
         query := "select rechnungsnummer,datum,kommentar from " &
                    "rechnung where kundennummer='" & knr & "';";
      end if;

      if (no_result = False) then
         sql.do_query (To_String (query), ergebnis);
         Freeze (Window1.Clist4);
         Gtk.Clist.Clear (Window1.Clist4);

         for I in 0 .. ergebnis.Tuples_Qt - 1 loop
            Pg.Get (ergebnis, I, 0, buffer);
            Pg.Get (ergebnis, I, 1, buffer2);
            Pg.Get (ergebnis, I, 2, buffer3);
            row := Gtk.Clist.Append (Window1.Clist4, To_String (buffer) +
                          To_String (buffer2) + To_String (buffer3));
         end loop;
         sql.forget (ergebnis);
         Thaw (Window1.Clist4);
      end if;
   end On_Search_Bill;

   --------------------------
   -- On_Clist4_Select_Row --
   --------------------------

   procedure On_Clist4_Select_Row
     (Object : access Gtk_Clist_Record'Class;
      Params : Gtk.Arguments.Gtk_Args)
   is
      Arg1 : Gint := To_Gint (Params, 1);
      Arg2 : Gint := To_Gint (Params, 2);
      Arg3 : Gdk_Event := To_Event (Params, 3);

      rechnr : Ustring;

   begin
      call_statusbar (" Rechnung wird angezeigt");
      Set_Text (Window1.Entry52, Get_Text (Window1.Clist4, Arg1, 0));
      rechnr := To_Ustring (on_zeige_rechnung); --  main call
      fill_details_widget (To_String (rechnr)); --  setzt die details
      Set_Page (Window1.Notebook3, 2);
   end On_Clist4_Select_Row;

   ---------------------
   -- Sortmode_Change --
   ---------------------

   procedure Sortmode_Change
     (Object : access Gtk_Clist_Record'Class;
      Params : Gtk.Arguments.Gtk_Args)
   is
      Arg1 : Gint := To_Gint (Params, 1);
   begin
      Freeze (Window1.Clist4);

      if (Arg1 = Get_Sort_Column (Window1.Clist4)) then
         if (Get_Sort_Type (Window1.Clist4) = Ascending) then
            Set_Sort_Type (Window1.Clist4, Descending);
         else
            Set_Sort_Type (Window1.Clist4, Ascending);
         end if;
      else
         Set_Sort_Column (Window1.Clist4, Arg1);
      end if;

      Sort (Window1.Clist4);
      Thaw (Window1.Clist4);
   end Sortmode_Change;

   --------------------------------
   -- On_Delete_Todo_Row_Clicked --
   --------------------------------

   procedure On_Delete_Todo_Row_Clicked
     (Object : access Gtk_Button_Record'Class)
   is
      use Gtk.Enums.Gint_List;
      row : Gint;
      ergebnis : Pg.Result_Type;
      query : Ustring := To_Ustring ("delete from todo where what='");
      Liste : Gtk.Enums.Gint_List.Glist;

   begin
      Freeze (Window1.Clist2);
      loop
         Liste := Get_Selection (Window1.Clist2);
         exit when Length (Liste) = 0;
         row := Get_Data (First (Liste));
         query := query & Get_Text (Window1.Clist2, row, 1) & "';";
         sql.do_query (To_String (query), ergebnis);
         Pg.Forget (ergebnis);
         Remove (Window1.Clist2, row);
         call_statusbar (" Eintrag" & Gint'Image (row + 1) &
                           (" gelöscht"));
         exit when Get_Selection_Mode (Window1.Clist2) = Selection_Browse;
      end loop;

      Thaw (Window1.Clist2);
   end On_Delete_Todo_Row_Clicked;

   --------------------
   -- fill_todo_list --
   --------------------

   procedure fill_todo_list
   is
      ergebnis : Pg.Result_Type;
      priority, what : Ustring;
      row : Gint;
      query : constant String := "select * from todo order by priority;";

   begin
      sql.do_query (query, ergebnis);
      Freeze (Window1.Clist2);
      Gtk.Clist.Clear (Window1.Clist2);
      for I in 0 .. ergebnis.Tuples_Qt - 1 loop
         Pg.Get (ergebnis, I, 0, priority);
         Pg.Get (ergebnis, I, 1, what);
         row := Gtk.Clist.Append (Window1.Clist2, To_String (priority) +
                                  To_String (what));
      end loop;

      Pg.Forget (ergebnis);
      Thaw (Window1.Clist2);
   end fill_todo_list;

   --------------------
   -- On_Reload_Todo --
   --------------------

   procedure On_Reload_Todo
     (Object : access Gtk_Button_Record'Class)
   is
   begin
      fill_todo_list;
   end On_Reload_Todo;

   ------------------------
   -- On_Change_Priority --
   ------------------------

   procedure On_Change_Priority
     (Object : access Gtk_Button_Record'Class)
   is
      use Gtk.Enums.Gint_List;
      Liste : Gtk.Enums.Gint_List.Glist;
      priority : constant String := Get_Text (Window1.Combo_Entry1);
      query : Ustring;
      row : Gint;
      ergebnis : Pg.Result_Type;
   begin
      Freeze (Window1.Clist2);
      loop
         Liste := Get_Selection (Window1.Clist2);
         exit when Length (Liste) = 0;
         row := Get_Data (First (Liste));
         query := To_Ustring ("update todo set priority='" &
                               priority & "' where what='" &
                               Get_Text (Window1.Clist2, row, 1) & "';");
         sql.do_query (To_String (query), ergebnis);
         Pg.Forget (ergebnis);
         Set_Text (Window1.Clist2, row, 0, priority);
         call_statusbar (" Eintrag" & Gint'Image (row + 1) &
                          (" geändert"));
         Unselect_Row (Window1.Clist2, row, 0);
         exit when Get_Selection_Mode (Window1.Clist2) = Selection_Browse;
      end loop;
      Thaw (Window1.Clist2);
   end On_Change_Priority;

   ----------------------------
   -- On_Todo_Insert_Clicked --
   ----------------------------

   procedure On_Todo_Insert_Clicked
     (Object : access Gtk_Button_Record'Class)
   is
      eintrag : constant String := Get_Text (Window1.Entry46);
      --  user : constant String := Get_Text (Window1.Entry47);
      priority : constant String := Get_Text (Window1.Combo_Entry1);
      --  todo : constant String := "1";
      row : Gint;
      ergebnis : Pg.Result_Type;
      --  buffer : Ustring;
      query : constant String := "insert into todo values('" & priority &
                                 "','" & eintrag & "');";

   begin
      if (eintrag /= "") then
         sql.do_query (query, ergebnis);
         Pg.Forget (ergebnis);
         row := Gtk.Clist.Append (Window1.Clist2, priority + eintrag);
         call_statusbar (" Neuen Todo-Eintrag aufgenommen");
      end if;
   end On_Todo_Insert_Clicked;

   -------------------------
   -- On_Todo_Called_Show --
   -------------------------

   procedure On_Todo_Called_Show
     (Object : access Gtk_Label_Record'Class)
   is
   begin
      fill_todo_list;
   end On_Todo_Called_Show;

   -------------------
   -- On_Write_Mail --
   -------------------

   procedure On_Write_Mail
     (Object : access Gtk_Button_Record'Class)
   is
   begin
      dispatcher.external (1);
   end On_Write_Mail;

   -------------------
   -- On_Browse_Web --
   -------------------

   procedure On_Browse_Web
     (Object : access Gtk_Button_Record'Class)
   is
   begin
      dispatcher.external (2);
   end On_Browse_Web;

   ------------------
   -- On_Read_News --
   ------------------

   procedure On_Read_News
     (Object : access Gtk_Button_Record'Class)
   is
   begin
      dispatcher.external (3);
   end On_Read_News;

   -------------------------
   -- On_Misc_Sql_Clicked --
   -------------------------

   procedure On_Misc_Sql_Clicked
     (Object : access Gtk_Button_Record'Class)
   is
      query : constant String := Get_Text (Window1.Entry66);
      ergebnis : Pg.Result_Type;
      buffer : Ustring;
      delsuccess : Boolean;

   begin
      sql.do_query (query, ergebnis);
      Freeze (Window1.Text2);
      Set_Point (Window1.Text2, 0);
      delsuccess := Forward_Delete (Window1.Text2, Get_Length (Window1.Text2));
      for I in 0 .. ergebnis.Tuples_Qt - 1 loop
         for J in 0 .. ergebnis.Fields_Qt - 1 loop
            Pg.Get (ergebnis, I, J, buffer);
            Gtk.Text.Insert (Window1.Text2, Gdk.Font.Null_Font,
                             Gdk.Color.Null_Color, Gdk.Color.Null_Color,
                             To_String (buffer & ASCII.HT));
         end loop;

         Gtk.Text.Insert (Window1.Text2, Gdk.Font.Null_Font,
                          Gdk.Color.Null_Color, Gdk.Color.Null_Color,
                          ASCII.LF & ASCII.NUL);
      end loop;

      Thaw (Window1.Text2);
      Pg.Forget (ergebnis);
      call_statusbar (" SQL-Command executed");
   end On_Misc_Sql_Clicked;

end Window1_Pkg.Callbacks;
