with Glib; use Glib;
with Gtk; use Gtk;
with Gdk.Types; use Gdk.Types;
with Gdk.Event; use Gdk.Event; --  adi
with Gtk.Widget; use Gtk.Widget;
with Gtk.Enums; use Gtk.Enums;
with Gtkada.Handlers; use Gtkada.Handlers;
with Callbacks_Project1; use Callbacks_Project1;
with Window1_Pkg.Callbacks; use Window1_Pkg.Callbacks;
with version;

package body Window1_Pkg is

   procedure Gtk_New (Window1 : out Window1_Access) is
   begin
      Window1 := new Window1_Record;
      Window1_Pkg.Initialize (Window1);
   end Gtk_New;

   procedure Initialize (Window1 : access Window1_Record'Class) is
      pragma Suppress (All_Checks);
      The_Accel_Group : Gtk_Accel_Group;
      Combo1_Items : String_List.Glist;

   begin
      Gtk.Window.Initialize (Window1, Window_Toplevel);
      Set_Title (Window1, version.ab_version);
      Set_Policy (Window1, False, True, False);
      Set_Position (Window1, Win_Pos_None);
      Set_Modal (Window1, False);

      Gtk_New_Vbox (Window1.Vbox1, False, 0);
      Add (Window1, Window1.Vbox1);

      Gtk_New (Window1.Menubar1);
      --  Set_Shadow_Type (Window1.Menubar1, Shadow_Out);
      Pack_Start (Window1.Vbox1, Window1.Menubar1, False, False, 0);

      Gtk_New (Window1.Datei1, "Datei");
      Set_Right_Justify (Window1.Datei1, False);
      Add (Window1.Menubar1, Window1.Datei1);

      Gtk_New (Window1.Datei1_Menu);
      Set_Submenu (Window1.Datei1, Window1.Datei1_Menu);

      Gtk_New (Window1.Beenden1, "Beenden");
      Set_Right_Justify (Window1.Beenden1, False);
      Gtk_New (The_Accel_Group);
      Add_Accel_Group (Window1, The_Accel_Group);
      Add_Accelerator (Window1.Beenden1, "activate",
        The_Accel_Group, GDK_Q, Gdk.Types.Mod1_Mask, Accel_Visible);
      Menu_Item_Callback.Connect
        (Window1.Beenden1, "activate",
         Menu_Item_Callback.To_Marshaller (On_Beenden1_Activate'Access));
      Add (Window1.Datei1_Menu, Window1.Beenden1);

      Gtk_New (Window1.Really_Print1, "Really Print");
      Set_Right_Justify (Window1.Really_Print1, False);
      Add (Window1.Menubar1, Window1.Really_Print1);

      Gtk_New (Window1.Really_Print1_Menu);
      Set_Submenu (Window1.Really_Print1, Window1.Really_Print1_Menu);

      Gtk_New (Window1.Always1, "Always");
      Set_Active (Window1.Always1, False);
      --  Set_Always_Show_Toggle (Window1.Always1, True);
      Check_Menu_Item_Callback.Connect
        (Window1.Always1, "activate",
         Check_Menu_Item_Callback.To_Marshaller (
          On_Really_Print_Always_Activate'Access));
      Add (Window1.Really_Print1_Menu, Window1.Always1);

      Gtk_New (Window1.Hilfe1, "Hilfe");
      Set_Right_Justify (Window1.Hilfe1, True);
      Menu_Item_Callback.Connect
        (Window1.Hilfe1, "activate",
         Menu_Item_Callback.To_Marshaller (On_Hilfe1_Activate'Access));
      Add (Window1.Menubar1, Window1.Hilfe1);

      Gtk_New (Window1.Hilfe1_Menu);
      Set_Submenu (Window1.Hilfe1, Window1.Hilfe1_Menu);

      Gtk_New (Window1.Über1, "Über");
      Set_Right_Justify (Window1.Über1, False);
      Add_Accelerator (Window1.Über1, "activate",
        The_Accel_Group, GDK_A, Gdk.Types.Mod1_Mask, Accel_Visible);
      Menu_Item_Callback.Connect
        (Window1.Über1, "activate",
         Menu_Item_Callback.To_Marshaller (On_About_Activate'Access));
      Add (Window1.Hilfe1_Menu, Window1.Über1);

      Gtk_New (Window1.Label56);
      Set_Alignment (Window1.Label56, 0.5, 0.5);
      Set_Padding (Window1.Label56, 0, 0);
      Set_Justify (Window1.Label56, Justify_Center);
      Set_Line_Wrap (Window1.Label56, False);
      Pack_Start (Window1.Vbox1, Window1.Label56, False, False, 0);

      Gtk_New (Window1.Notebook1);
      Set_Scrollable (Window1.Notebook1, False);
      Set_Show_Border (Window1.Notebook1, True);
      Set_Show_Tabs (Window1.Notebook1, True);
      Set_Tab_Hborder (Window1.Notebook1, 2);
      Set_Tab_Vborder (Window1.Notebook1, 2);
      Set_Tab_Pos (Window1.Notebook1, Pos_Top);
      Pack_Start (Window1.Vbox1, Window1.Notebook1, True, True, 0);

      Gtk_New (Window1.Frame3);
      Set_Shadow_Type (Window1.Frame3, Shadow_Etched_In);
      Add (Window1.Notebook1, Window1.Frame3);

      Gtk_New (Window1.Notebook2);
      Set_Scrollable (Window1.Notebook2, False);
      Set_Show_Border (Window1.Notebook2, True);
      Set_Show_Tabs (Window1.Notebook2, True);
      Set_Tab_Hborder (Window1.Notebook2, 2);
      Set_Tab_Vborder (Window1.Notebook2, 2);
      Set_Tab_Pos (Window1.Notebook2, Pos_Top);
      Add (Window1.Frame3, Window1.Notebook2);

      Gtk_New_Vbox (Window1.Vbox3, False, 0);
      Add (Window1.Notebook2, Window1.Vbox3);

      Gtk_New (Window1.Table2, 12, 2, False);
      Set_Row_Spacings (Window1.Table2, 0);
      Set_Col_Spacings (Window1.Table2, 0);
      Pack_Start (Window1.Vbox3, Window1.Table2, True, True, 0);

      Gtk_New (Window1.Entry13);
      Set_Editable (Window1.Entry13, True);
      Set_Max_Length (Window1.Entry13, 0);
      Set_Text (Window1.Entry13, "");
      Set_Visibility (Window1.Entry13, True);
      Attach (Window1.Table2, Window1.Entry13, 1, 2, 1, 2,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry14);
      Set_Editable (Window1.Entry14, True);
      Set_Max_Length (Window1.Entry14, 0);
      Set_Text (Window1.Entry14, "");
      Set_Visibility (Window1.Entry14, True);
      Attach (Window1.Table2, Window1.Entry14, 1, 2, 2, 3,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry15);
      Set_Editable (Window1.Entry15, True);
      Set_Max_Length (Window1.Entry15, 0);
      Set_Text (Window1.Entry15, "");
      Set_Visibility (Window1.Entry15, True);
      Attach (Window1.Table2, Window1.Entry15, 1, 2, 3, 4,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry16);
      Set_Editable (Window1.Entry16, True);
      Set_Max_Length (Window1.Entry16, 0);
      Set_Text (Window1.Entry16, "");
      Set_Visibility (Window1.Entry16, True);
      Attach (Window1.Table2, Window1.Entry16, 1, 2, 4, 5,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry17);
      Set_Editable (Window1.Entry17, True);
      Set_Max_Length (Window1.Entry17, 0);
      Set_Text (Window1.Entry17, "");
      Set_Visibility (Window1.Entry17, True);
      Attach (Window1.Table2, Window1.Entry17, 1, 2, 5, 6,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Label21, "Vorname");
      Set_Alignment (Window1.Label21, 0.0, 0.5);
      Set_Padding (Window1.Label21, 0, 0);
      Set_Justify (Window1.Label21, Justify_Center);
      Set_Line_Wrap (Window1.Label21, False);
      Attach (Window1.Table2, Window1.Label21, 0, 1, 1, 2,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Label22, "Name");
      Set_Alignment (Window1.Label22, 0.0, 0.5);
      Set_Padding (Window1.Label22, 0, 0);
      Set_Justify (Window1.Label22, Justify_Center);
      Set_Line_Wrap (Window1.Label22, False);
      Attach (Window1.Table2, Window1.Label22, 0, 1, 2, 3,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Label23, "Firma");
      Set_Alignment (Window1.Label23, 0.0, 0.5);
      Set_Padding (Window1.Label23, 0, 0);
      Set_Justify (Window1.Label23, Justify_Center);
      Set_Line_Wrap (Window1.Label23, False);
      Attach (Window1.Table2, Window1.Label23, 0, 1, 3, 4,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Label24, ("Straße"));
      Set_Alignment (Window1.Label24, 0.0, 0.5);
      Set_Padding (Window1.Label24, 0, 0);
      Set_Justify (Window1.Label24, Justify_Center);
      Set_Line_Wrap (Window1.Label24, False);
      Attach (Window1.Table2, Window1.Label24, 0, 1, 4, 5,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Label25, "PLZ");
      Set_Alignment (Window1.Label25, 0.0, 0.5);
      Set_Padding (Window1.Label25, 0, 0);
      Set_Justify (Window1.Label25, Justify_Center);
      Set_Line_Wrap (Window1.Label25, False);
      Attach (Window1.Table2, Window1.Label25, 0, 1, 5, 6,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Label26, "Ort");
      Set_Alignment (Window1.Label26, 0.0, 0.5);
      Set_Padding (Window1.Label26, 0, 0);
      Set_Justify (Window1.Label26, Justify_Center);
      Set_Line_Wrap (Window1.Label26, False);
      Attach (Window1.Table2, Window1.Label26, 0, 1, 6, 7,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Label27, "Telefon");
      Set_Alignment (Window1.Label27, 0.0, 0.5);
      Set_Padding (Window1.Label27, 0, 0);
      Set_Justify (Window1.Label27, Justify_Center);
      Set_Line_Wrap (Window1.Label27, False);
      Attach (Window1.Table2, Window1.Label27, 0, 1, 7, 8,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Label28, "Email");
      Set_Alignment (Window1.Label28, 0.0, 0.5);
      Set_Padding (Window1.Label28, 0, 0);
      Set_Justify (Window1.Label28, Justify_Center);
      Set_Line_Wrap (Window1.Label28, False);
      Attach (Window1.Table2, Window1.Label28, 0, 1, 10, 11,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Label29, "Funktelefon");
      Set_Alignment (Window1.Label29, 0.0, 0.5);
      Set_Padding (Window1.Label29, 0, 0);
      Set_Justify (Window1.Label29, Justify_Center);
      Set_Line_Wrap (Window1.Label29, False);
      Attach (Window1.Table2, Window1.Label29, 0, 1, 9, 10,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Label30, "Telefax");
      Set_Alignment (Window1.Label30, 0.0, 0.5);
      Set_Padding (Window1.Label30, 0, 0);
      Set_Justify (Window1.Label30, Justify_Center);
      Set_Line_Wrap (Window1.Label30, False);
      Attach (Window1.Table2, Window1.Label30, 0, 1, 8, 9,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Entry18);
      Set_Editable (Window1.Entry18, True);
      Set_Max_Length (Window1.Entry18, 0);
      Set_Text (Window1.Entry18, "");
      Set_Visibility (Window1.Entry18, True);
      Attach (Window1.Table2, Window1.Entry18, 1, 2, 6, 7,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry20);
      Set_Editable (Window1.Entry20, True);
      Set_Max_Length (Window1.Entry20, 0);
      Set_Text (Window1.Entry20, "");
      Set_Visibility (Window1.Entry20, True);
      Attach (Window1.Table2, Window1.Entry20, 1, 2, 8, 9,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry19);
      Set_Editable (Window1.Entry19, True);
      Set_Max_Length (Window1.Entry19, 0);
      Set_Text (Window1.Entry19, "");
      Set_Visibility (Window1.Entry19, True);
      Attach (Window1.Table2, Window1.Entry19, 1, 2, 7, 8,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry21);
      Set_Editable (Window1.Entry21, True);
      Set_Max_Length (Window1.Entry21, 0);
      Set_Text (Window1.Entry21, "");
      Set_Visibility (Window1.Entry21, True);
      Attach (Window1.Table2, Window1.Entry21, 1, 2, 9, 10,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry22);
      Set_Editable (Window1.Entry22, True);
      Set_Max_Length (Window1.Entry22, 0);
      Set_Text (Window1.Entry22, "");
      Set_Visibility (Window1.Entry22, True);
      Attach (Window1.Table2, Window1.Entry22, 1, 2, 10, 11,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Label31, "Feldname");
      Set_Alignment (Window1.Label31, 0.71, 0.5);
      Set_Padding (Window1.Label31, 0, 0);
      Set_Justify (Window1.Label31, Justify_Right);
      Set_Line_Wrap (Window1.Label31, False);
      Set_Sensitive (Window1.Label31, False);
      Attach (Window1.Table2, Window1.Label31, 0, 1, 0, 1,
        Fill, 0,
        0, 0);

      Gtk_New (Window1.Label32, "Feldeintrag");
      Set_Alignment (Window1.Label32, 0.95, 0.5);
      Set_Padding (Window1.Label32, 0, 8);
      Set_Justify (Window1.Label32, Justify_Right);
      Set_Line_Wrap (Window1.Label32, False);
      Set_Sensitive (Window1.Label32, False);
      Attach (Window1.Table2, Window1.Label32, 1, 2, 0, 1,
        Fill, 0,
        0, 0);

      Gtk_New (Window1.Label111, "Attribute");
      Set_Alignment (Window1.Label111, 0.0, 0.5);
      Set_Padding (Window1.Label111, 0, 0);
      Set_Justify (Window1.Label111, Justify_Center);
      Set_Line_Wrap (Window1.Label111, False);
      Attach (Window1.Table2, Window1.Label111, 0, 1, 11, 12,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Checkbutton2,  ("Geschäftskunde"));
      Set_Active (Window1.Checkbutton2, False);
      Attach (Window1.Table2, Window1.Checkbutton2, 1, 2, 11, 12,
        Fill, 0,
        0, 0);

      Gtk_New (Window1.Hbuttonbox2);
      Set_Spacing (Window1.Hbuttonbox2, 30);
      Set_Layout (Window1.Hbuttonbox2, Buttonbox_Spread);
      Set_Child_Size (Window1.Hbuttonbox2, 85, 27);
      Set_Child_Ipadding (Window1.Hbuttonbox2, 7, 0);
      Pack_Start (Window1.Vbox3, Window1.Hbuttonbox2, False, False, 0);

      Gtk_New (Window1.Button3, "Kunde eintragen");
      Set_Relief (Window1.Button3, Relief_Normal);
      Set_Flags (Window1.Button3, Can_Default);
      Button_Callback.Connect
        (Window1.Button3, "clicked",
         Button_Callback.To_Marshaller (On_Button10_Clicked'Access));
      Add (Window1.Hbuttonbox2, Window1.Button3);

      Gtk_New (Window1.Button4, "Abbrechen");
      Set_Relief (Window1.Button4, Relief_Normal);
      Set_Flags (Window1.Button4, Can_Default);
      Button_Callback.Connect
        (Window1.Button4, "clicked",
         Button_Callback.To_Marshaller (On_Button11_Clicked'Access));
      Add (Window1.Hbuttonbox2, Window1.Button4);

      Gtk_New (Window1.Label4, "Neu");
      Set_Alignment (Window1.Label4, 0.5, 0.5);
      Set_Padding (Window1.Label4, 0, 0);
      Set_Justify (Window1.Label4, Justify_Center);
      Set_Line_Wrap (Window1.Label4, False);
      Set_Tab (Window1.Notebook2, 0, Window1.Label4);

      Gtk_New_Vbox (Window1.Vbox4, False, 0);
      Add (Window1.Notebook2, Window1.Vbox4);

      Gtk_New_Hseparator (Window1.Hseparator2);
      Pack_Start (Window1.Vbox4, Window1.Hseparator2, True, True, 0);

      Gtk_New (Window1.Table3, 3, 2, False);
      Set_Row_Spacings (Window1.Table3, 0);
      Set_Col_Spacings (Window1.Table3, 0);
      Pack_Start (Window1.Vbox4, Window1.Table3, True, True, 0);

      Gtk_New (Window1.Entry23);
      Set_Editable (Window1.Entry23, True);
      Set_Max_Length (Window1.Entry23, 0);
      Set_Text (Window1.Entry23, "");
      Set_Visibility (Window1.Entry23, True);
      Attach (Window1.Table3, Window1.Entry23, 1, 2, 0, 1,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry24);
      Set_Editable (Window1.Entry24, True);
      Set_Max_Length (Window1.Entry24, 0);
      Set_Text (Window1.Entry24, "");
      Set_Visibility (Window1.Entry24, True);
      Attach (Window1.Table3, Window1.Entry24, 1, 2, 1, 2,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry25);
      Set_Editable (Window1.Entry25, True);
      Set_Max_Length (Window1.Entry25, 0);
      Set_Text (Window1.Entry25, "");
      Set_Visibility (Window1.Entry25, True);
      Attach (Window1.Table3, Window1.Entry25, 1, 2, 2, 3,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Label33, "Kundennummer");
      Set_Alignment (Window1.Label33, 0.0, 0.5);
      Set_Padding (Window1.Label33, 0, 0);
      Set_Justify (Window1.Label33, Justify_Center);
      Set_Line_Wrap (Window1.Label33, False);
      Attach (Window1.Table3, Window1.Label33, 0, 1, 0, 1,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Label34, "Vorname");
      Set_Alignment (Window1.Label34, 0.0, 0.5);
      Set_Padding (Window1.Label34, 0, 0);
      Set_Justify (Window1.Label34, Justify_Center);
      Set_Line_Wrap (Window1.Label34, False);
      Attach (Window1.Table3, Window1.Label34, 0, 1, 1, 2,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Label35, "Name");
      Set_Alignment (Window1.Label35, 0.0, 0.5);
      Set_Padding (Window1.Label35, 0, 0);
      Set_Justify (Window1.Label35, Justify_Left);
      Set_Line_Wrap (Window1.Label35, False);
      Attach (Window1.Table3, Window1.Label35, 0, 1, 2, 3,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Button5, "Such den Kunden");
      Set_Relief (Window1.Button5, Relief_Normal);
      Pack_Start (Window1.Vbox4, Window1.Button5, True, False, 0);
      Button_Callback.Connect
        (Window1.Button5, "clicked",
         Button_Callback.To_Marshaller (On_Suchdenkunden_Clicked'Access));

      Gtk_New (Window1.Label5, "Suchen");
      Set_Alignment (Window1.Label5, 0.5, 0.5);
      Set_Padding (Window1.Label5, 0, 0);
      Set_Justify (Window1.Label5, Justify_Center);
      Set_Line_Wrap (Window1.Label5, False);
      Set_Tab (Window1.Notebook2, 1, Window1.Label5);

      Gtk_New_Vbox (Window1.Vbox5, False, 0);
      Add (Window1.Notebook2, Window1.Vbox5);

      Gtk_New (Window1.Table4, 12, 2, False);
      Set_Row_Spacings (Window1.Table4, 0);
      Set_Col_Spacings (Window1.Table4, 0);
      Pack_Start (Window1.Vbox5, Window1.Table4, True, True, 0);

      Gtk_New (Window1.Entry26);
      Set_Editable (Window1.Entry26, False);
      Set_Max_Length (Window1.Entry26, 0);
      Set_Text (Window1.Entry26, "");
      Set_Visibility (Window1.Entry26, True);
      Attach (Window1.Table4, Window1.Entry26, 1, 2, 1, 2,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry27);
      Set_Editable (Window1.Entry27, True);
      Set_Max_Length (Window1.Entry27, 0);
      Set_Text (Window1.Entry27, "");
      Set_Visibility (Window1.Entry27, True);
      Attach (Window1.Table4, Window1.Entry27, 1, 2, 2, 3,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry28);
      Set_Editable (Window1.Entry28, True);
      Set_Max_Length (Window1.Entry28, 0);
      Set_Text (Window1.Entry28, "");
      Set_Visibility (Window1.Entry28, True);
      Attach (Window1.Table4, Window1.Entry28, 1, 2, 3, 4,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry29);
      Set_Editable (Window1.Entry29, True);
      Set_Max_Length (Window1.Entry29, 0);
      Set_Text (Window1.Entry29, "");
      Set_Visibility (Window1.Entry29, True);
      Attach (Window1.Table4, Window1.Entry29, 1, 2, 4, 5,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry30);
      Set_Editable (Window1.Entry30, True);
      Set_Max_Length (Window1.Entry30, 0);
      Set_Text (Window1.Entry30, "");
      Set_Visibility (Window1.Entry30, True);
      Attach (Window1.Table4, Window1.Entry30, 1, 2, 5, 6,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry31);
      Set_Editable (Window1.Entry31, True);
      Set_Max_Length (Window1.Entry31, 0);
      Set_Text (Window1.Entry31, "");
      Set_Visibility (Window1.Entry31, True);
      Attach (Window1.Table4, Window1.Entry31, 1, 2, 6, 7,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Label36, "Kundennummer");
      Set_Alignment (Window1.Label36, 0.0, 0.5);
      Set_Padding (Window1.Label36, 0, 0);
      Set_Justify (Window1.Label36, Justify_Center);
      Set_Line_Wrap (Window1.Label36, False);
      Attach (Window1.Table4, Window1.Label36, 0, 1, 1, 2,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Label37, "Vorname");
      Set_Alignment (Window1.Label37, 0.0, 0.5);
      Set_Padding (Window1.Label37, 0, 0);
      Set_Justify (Window1.Label37, Justify_Center);
      Set_Line_Wrap (Window1.Label37, False);
      Attach (Window1.Table4, Window1.Label37, 0, 1, 2, 3,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Label38, "Name");
      Set_Alignment (Window1.Label38, 0.0, 0.5);
      Set_Padding (Window1.Label38, 0, 0);
      Set_Justify (Window1.Label38, Justify_Center);
      Set_Line_Wrap (Window1.Label38, False);
      Attach (Window1.Table4, Window1.Label38, 0, 1, 3, 4,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Label39, "Firma");
      Set_Alignment (Window1.Label39, 0.0, 0.5);
      Set_Padding (Window1.Label39, 0, 0);
      Set_Justify (Window1.Label39, Justify_Center);
      Set_Line_Wrap (Window1.Label39, False);
      Attach (Window1.Table4, Window1.Label39, 0, 1, 4, 5,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Label40,  ("Straße"));
      Set_Alignment (Window1.Label40, 0.0, 0.5);
      Set_Padding (Window1.Label40, 0, 0);
      Set_Justify (Window1.Label40, Justify_Center);
      Set_Line_Wrap (Window1.Label40, False);
      Attach (Window1.Table4, Window1.Label40, 0, 1, 5, 6,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Label41, "PLZ");
      Set_Alignment (Window1.Label41, 0.0, 0.5);
      Set_Padding (Window1.Label41, 0, 0);
      Set_Justify (Window1.Label41, Justify_Center);
      Set_Line_Wrap (Window1.Label41, False);
      Attach (Window1.Table4, Window1.Label41, 0, 1, 6, 7,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Label42, "Ort");
      Set_Alignment (Window1.Label42, 0.0, 0.5);
      Set_Padding (Window1.Label42, 0, 0);
      Set_Justify (Window1.Label42, Justify_Center);
      Set_Line_Wrap (Window1.Label42, False);
      Attach (Window1.Table4, Window1.Label42, 0, 1, 7, 8,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Label43, "Telefon");
      Set_Alignment (Window1.Label43, 0.0, 0.5);
      Set_Padding (Window1.Label43, 0, 0);
      Set_Justify (Window1.Label43, Justify_Center);
      Set_Line_Wrap (Window1.Label43, False);
      Attach (Window1.Table4, Window1.Label43, 0, 1, 8, 9,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Label45, "Funktelefon");
      Set_Alignment (Window1.Label45, 0.0, 0.5);
      Set_Padding (Window1.Label45, 0, 0);
      Set_Justify (Window1.Label45, Justify_Center);
      Set_Line_Wrap (Window1.Label45, False);
      Attach (Window1.Table4, Window1.Label45, 0, 1, 10, 11,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Label46, "Telefax");
      Set_Alignment (Window1.Label46, 0.0, 0.5);
      Set_Padding (Window1.Label46, 0, 0);
      Set_Justify (Window1.Label46, Justify_Center);
      Set_Line_Wrap (Window1.Label46, False);
      Attach (Window1.Table4, Window1.Label46, 0, 1, 9, 10,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Entry32);
      Set_Editable (Window1.Entry32, True);
      Set_Max_Length (Window1.Entry32, 0);
      Set_Text (Window1.Entry32, "");
      Set_Visibility (Window1.Entry32, True);
      Attach (Window1.Table4, Window1.Entry32, 1, 2, 7, 8,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry34);
      Set_Editable (Window1.Entry34, True);
      Set_Max_Length (Window1.Entry34, 0);
      Set_Text (Window1.Entry34, "");
      Set_Visibility (Window1.Entry34, True);
      Attach (Window1.Table4, Window1.Entry34, 1, 2, 9, 10,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry33);
      Set_Editable (Window1.Entry33, True);
      Set_Max_Length (Window1.Entry33, 0);
      Set_Text (Window1.Entry33, "");
      Set_Visibility (Window1.Entry33, True);
      Attach (Window1.Table4, Window1.Entry33, 1, 2, 8, 9,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry35);
      Set_Editable (Window1.Entry35, True);
      Set_Max_Length (Window1.Entry35, 0);
      Set_Text (Window1.Entry35, "");
      Set_Visibility (Window1.Entry35, True);
      Attach (Window1.Table4, Window1.Entry35, 1, 2, 10, 11,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry36);
      Set_Editable (Window1.Entry36, True);
      Set_Max_Length (Window1.Entry36, 0);
      Set_Text (Window1.Entry36, "");
      Set_Visibility (Window1.Entry36, True);
      Attach (Window1.Table4, Window1.Entry36, 1, 2, 11, 12,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Label47, "Feldname");
      Set_Alignment (Window1.Label47, 0.71, 0.5);
      Set_Padding (Window1.Label47, 0, 0);
      Set_Justify (Window1.Label47, Justify_Right);
      Set_Line_Wrap (Window1.Label47, False);
      Set_Sensitive (Window1.Label47, False);
      Attach (Window1.Table4, Window1.Label47, 0, 1, 0, 1,
        Fill, 0,
        0, 0);

      Gtk_New (Window1.Label48, "Feldeintrag");
      Set_Alignment (Window1.Label48, 0.95, 0.5);
      Set_Padding (Window1.Label48, 0, 8);
      Set_Justify (Window1.Label48, Justify_Right);
      Set_Line_Wrap (Window1.Label48, False);
      Set_Sensitive (Window1.Label48, False);
      Attach (Window1.Table4, Window1.Label48, 1, 2, 0, 1,
        Fill, 0,
        0, 0);

      Gtk_New_Hbox (Window1.Hbox5, False, 0);
      Attach (Window1.Table4, Window1.Hbox5, 0, 1, 11, 12,
        Shrink or Fill, Shrink or Fill,
        0, 0);

      Gtk_New (Window1.Button28, "Email");
      Set_Relief (Window1.Button28, Relief_None);
      Pack_Start (Window1.Hbox5, Window1.Button28, False, True, 2);
      Button_Callback.Connect
        (Window1.Button28, "pressed",
         Button_Callback.To_Marshaller (On_Mail_Client_Pressed'Access));

      Window1.Pixmap1 := Create_Pixmap ("/usr/local/share/adabill/mail.xpm",
                                        Window1);
      Set_Alignment (Window1.Pixmap1, 0.5, 0.5);
      Set_Padding (Window1.Pixmap1, 14, 0);
      Pack_Start (Window1.Hbox5, Window1.Pixmap1, False, False, 0);

      Gtk_New (Window1.Hbuttonbox3);
      Set_Spacing (Window1.Hbuttonbox3, 30);
      Set_Layout (Window1.Hbuttonbox3, Buttonbox_Spread);
      Set_Child_Size (Window1.Hbuttonbox3, 85, 27);
      Set_Child_Ipadding (Window1.Hbuttonbox3, 7, 0);
      Pack_Start (Window1.Vbox5, Window1.Hbuttonbox3, False, False, 0);

      Gtk_New (Window1.Button6,  ("Kunde ändern"));
      Set_Relief (Window1.Button6, Relief_Normal);
      Set_Flags (Window1.Button6, Can_Default);
      Button_Callback.Connect
        (Window1.Button6, "clicked",
         Button_Callback.To_Marshaller (On_Modkunde_Clicked'Access));
      Add (Window1.Hbuttonbox3, Window1.Button6);

      Gtk_New (Window1.Button7, "Abbrechen");
      Set_Relief (Window1.Button7, Relief_Normal);
      Set_Flags (Window1.Button7, Can_Default);
      Button_Callback.Connect
        (Window1.Button7, "clicked",
         Button_Callback.To_Marshaller (On_Button11_Clicked'Access));
      Add (Window1.Hbuttonbox3, Window1.Button7);

      Gtk_New (Window1.Label6,  ("Ändern"));
      Set_Alignment (Window1.Label6, 0.5, 0.5);
      Set_Padding (Window1.Label6, 0, 0);
      Set_Justify (Window1.Label6, Justify_Center);
      Set_Line_Wrap (Window1.Label6, False);
      Set_Tab (Window1.Notebook2, 2, Window1.Label6);

      Gtk_New (Window1.Label1, "Kunde");
      Set_Alignment (Window1.Label1, 0.5, 0.5);
      Set_Padding (Window1.Label1, 0, 0);
      Set_Justify (Window1.Label1, Justify_Center);
      Set_Line_Wrap (Window1.Label1, False);
      Set_Tab (Window1.Notebook1, 0, Window1.Label1);

      Gtk_New (Window1.Frame1);
      Set_Shadow_Type (Window1.Frame1, Shadow_Etched_In);
      Add (Window1.Notebook1, Window1.Frame1);

      Gtk_New (Window1.Notebook3);
      Set_Scrollable (Window1.Notebook3, False);
      Set_Show_Border (Window1.Notebook3, True);
      Set_Show_Tabs (Window1.Notebook3, True);
      Set_Tab_Hborder (Window1.Notebook3, 2);
      Set_Tab_Vborder (Window1.Notebook3, 2);
      Set_Tab_Pos (Window1.Notebook3, Pos_Top);
      Add (Window1.Frame1, Window1.Notebook3);

      Gtk_New_Vbox (Window1.Vbox6, False, 0);
      Add (Window1.Notebook3, Window1.Vbox6);

      Gtk_New_Hseparator (Window1.Hseparator10);
      Pack_Start (Window1.Vbox6, Window1.Hseparator10, True, True, 0);

      Gtk_New (Window1.Table5, 3, 2, False);
      Set_Row_Spacings (Window1.Table5, 0);
      Set_Col_Spacings (Window1.Table5, 0);
      Pack_Start (Window1.Vbox6, Window1.Table5, True, True, 0);

      Gtk_New (Window1.Label52, "Kundennummer");
      Set_Alignment (Window1.Label52, 0.0, 0.5);
      Set_Padding (Window1.Label52, 0, 0);
      Set_Justify (Window1.Label52, Justify_Center);
      Set_Line_Wrap (Window1.Label52, False);
      Attach (Window1.Table5, Window1.Label52, 0, 1, 0, 1,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Label53, "Vorname");
      Set_Alignment (Window1.Label53, 0.0, 0.5);
      Set_Padding (Window1.Label53, 0, 0);
      Set_Justify (Window1.Label53, Justify_Center);
      Set_Line_Wrap (Window1.Label53, False);
      Attach (Window1.Table5, Window1.Label53, 0, 1, 1, 2,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Label54, "Name");
      Set_Alignment (Window1.Label54, 0.0, 0.5);
      Set_Padding (Window1.Label54, 0, 0);
      Set_Justify (Window1.Label54, Justify_Left);
      Set_Line_Wrap (Window1.Label54, False);
      Attach (Window1.Table5, Window1.Label54, 0, 1, 2, 3,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Entry39);
      Set_Editable (Window1.Entry39, True);
      Set_Max_Length (Window1.Entry39, 0);
      Set_Text (Window1.Entry39, "");
      Set_Visibility (Window1.Entry39, True);
      Attach (Window1.Table5, Window1.Entry39, 1, 2, 2, 3,
        Expand or Fill, 0,
        4, 2);

      Gtk_New (Window1.Entry38);
      Set_Editable (Window1.Entry38, True);
      Set_Max_Length (Window1.Entry38, 0);
      Set_Text (Window1.Entry38, "");
      Set_Visibility (Window1.Entry38, True);
      Attach (Window1.Table5, Window1.Entry38, 1, 2, 1, 2,
        Expand or Fill, 0,
        4, 2);

      Gtk_New (Window1.Entry37);
      Set_Editable (Window1.Entry37, True);
      Set_Max_Length (Window1.Entry37, 0);
      Set_Text (Window1.Entry37, "");
      Set_Visibility (Window1.Entry37, True);
      Attach (Window1.Table5, Window1.Entry37, 1, 2, 0, 1,
        Expand or Fill, 0,
        4, 2);

      Gtk_New (Window1.Button8, "Rechnung anlegen");
      Set_Relief (Window1.Button8, Relief_Normal);
      Pack_Start (Window1.Vbox6, Window1.Button8, True, False, 0);
      Button_Callback.Connect
        (Window1.Button8, "clicked",
         Button_Callback.To_Marshaller (On_Neurechnung_Clicked'Access));

      Gtk_New (Window1.Label49, "Neu");
      Set_Alignment (Window1.Label49, 0.5, 0.5);
      Set_Padding (Window1.Label49, 0, 0);
      Set_Justify (Window1.Label49, Justify_Center);
      Set_Line_Wrap (Window1.Label49, False);
      Set_Tab (Window1.Notebook3, 0, Window1.Label49);

      Gtk_New_Vbox (Window1.Vbox7, False, 0);
      Add (Window1.Notebook3, Window1.Vbox7);

      Gtk_New_Hseparator (Window1.Hseparator3);
      Pack_Start (Window1.Vbox7, Window1.Hseparator3, True, True, 0);

      Gtk_New (Window1.Table6, 4, 2, False);
      Set_Row_Spacings (Window1.Table6, 0);
      Set_Col_Spacings (Window1.Table6, 0);
      Pack_Start (Window1.Vbox7, Window1.Table6, True, True, 0);

      Gtk_New (Window1.Label57, "Menge");
      Set_Alignment (Window1.Label57, 0.0, 0.5);
      Set_Padding (Window1.Label57, 4, 2);
      Set_Justify (Window1.Label57, Justify_Center);
      Set_Line_Wrap (Window1.Label57, False);
      Attach (Window1.Table6, Window1.Label57, 0, 1, 1, 2,
        Fill, 0,
        0, 0);

      Gtk_New (Window1.Label58, "Artikelbezeichnung");
      Set_Alignment (Window1.Label58, 0.0, 0.5);
      Set_Padding (Window1.Label58, 4, 2);
      Set_Justify (Window1.Label58, Justify_Center);
      Set_Line_Wrap (Window1.Label58, False);
      Attach (Window1.Table6, Window1.Label58, 0, 1, 2, 3,
        Fill, 0,
        0, 0);

      Gtk_New (Window1.Label59, "Einzelpreis");
      Set_Alignment (Window1.Label59, 0.0, 0.5);
      Set_Padding (Window1.Label59, 4, 2);
      Set_Justify (Window1.Label59, Justify_Center);
      Set_Line_Wrap (Window1.Label59, False);
      Attach (Window1.Table6, Window1.Label59, 0, 1, 3, 4,
        Fill, 0,
        0, 0);

      Gtk_New (Window1.Label60, "Rechnungsnummer");
      Set_Alignment (Window1.Label60, 0.0, 0.5);
      Set_Padding (Window1.Label60, 4, 2);
      Set_Justify (Window1.Label60, Justify_Center);
      Set_Line_Wrap (Window1.Label60, False);
      Attach (Window1.Table6, Window1.Label60, 0, 1, 0, 1,
        Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry42);
      Set_Editable (Window1.Entry42, True);
      Set_Max_Length (Window1.Entry42, 0);
      Set_Text (Window1.Entry42, "");
      Set_Visibility (Window1.Entry42, True);
      Attach (Window1.Table6, Window1.Entry42, 1, 2, 0, 1,
        Expand or Fill, 0,
        4, 2);

      Gtk_New (Window1.Entry44);
      Set_Editable (Window1.Entry44, True);
      Set_Max_Length (Window1.Entry44, 0);
      Set_Text (Window1.Entry44, "");
      Set_Visibility (Window1.Entry44, True);
      Attach (Window1.Table6, Window1.Entry44, 1, 2, 2, 3,
        Expand or Fill, 0,
        4, 2);

      Gtk_New (Window1.Entry43);
      Set_Editable (Window1.Entry43, True);
      Set_Max_Length (Window1.Entry43, 0);
      Set_Text (Window1.Entry43, "");
      Set_Visibility (Window1.Entry43, True);
      Attach (Window1.Table6, Window1.Entry43, 1, 2, 3, 4,
        Expand or Fill, 0,
        4, 2);

      Gtk_New (Window1.Entry45);
      Set_Editable (Window1.Entry45, True);
      Set_Max_Length (Window1.Entry45, 0);
      Set_Text (Window1.Entry45, "");
      Set_Visibility (Window1.Entry45, True);
      Attach (Window1.Table6, Window1.Entry45, 1, 2, 1, 2,
        Expand or Fill, 0,
        4, 2);

      Gtk_New (Window1.Hbuttonbox4);
      Set_Spacing (Window1.Hbuttonbox4, 30);
      Set_Layout (Window1.Hbuttonbox4, Buttonbox_Spread);
      Set_Child_Size (Window1.Hbuttonbox4, 85, 27);
      Set_Child_Ipadding (Window1.Hbuttonbox4, 7, 0);
      Pack_Start (Window1.Vbox7, Window1.Hbuttonbox4, True, True, 0);

      Gtk_New (Window1.Button9,  ("Hinzufügen"));
      Set_Relief (Window1.Button9, Relief_Normal);
      Set_Flags (Window1.Button9, Can_Default);
      Button_Callback.Connect
        (Window1.Button9, "clicked",
         Button_Callback.To_Marshaller (On_Posten_Hinzu_Clicked'Access));
      Add (Window1.Hbuttonbox4, Window1.Button9);

      Gtk_New (Window1.Button10, "Fertig");
      Set_Relief (Window1.Button10, Relief_Normal);
      Set_Flags (Window1.Button10, Can_Default);
      Button_Callback.Connect
        (Window1.Button10, "clicked",
         Button_Callback.To_Marshaller (On_Rechnung_Fertig_Clicked'Access));
      Add (Window1.Hbuttonbox4, Window1.Button10);

      Gtk_New (Window1.Label50,  ("Ändern"));
      Set_Alignment (Window1.Label50, 0.5, 0.5);
      Set_Padding (Window1.Label50, 0, 0);
      Set_Justify (Window1.Label50, Justify_Center);
      Set_Line_Wrap (Window1.Label50, False);
      Set_Tab (Window1.Notebook3, 1, Window1.Label50);

      Gtk_New (Window1.Frame4);
      Set_Shadow_Type (Window1.Frame4, Shadow_Etched_In);
      Add (Window1.Notebook3, Window1.Frame4);

      Gtk_New_Vbox (Window1.Vbox9, False, 0);
      Add (Window1.Frame4, Window1.Vbox9);

      Gtk_New_Hbox (Window1.Hbox3, False, 0);
      Pack_Start (Window1.Vbox9, Window1.Hbox3, False, True, 4);

      Gtk_New (Window1.Label87, "Rechnungsnummer:");
      Set_Alignment (Window1.Label87, 0.5, 0.5);
      Set_Padding (Window1.Label87, 4, 2);
      Set_Justify (Window1.Label87, Justify_Center);
      Set_Line_Wrap (Window1.Label87, False);
      Pack_Start (Window1.Hbox3, Window1.Label87, False, False, 0);

      Gtk_New (Window1.Entry52);
      Set_Editable (Window1.Entry52, True);
      Set_Max_Length (Window1.Entry52, 0);
      Set_Text (Window1.Entry52, "");
      Set_Visibility (Window1.Entry52, True);
      Pack_Start (Window1.Hbox3, Window1.Entry52, False, True, 4);

      Gtk_New (Window1.Button16, "Anzeigen");
      Set_Relief (Window1.Button16, Relief_Normal);
      Pack_Start (Window1.Hbox3, Window1.Button16, False, False, 0);
      Button_Callback.Connect
        (Window1.Button16, "clicked",
         Button_Callback.To_Marshaller (On_Zeige_Rechnung_Clicked'Access));

      Gtk_New (Window1.Scrolledwindow2);
      Set_Policy (Window1.Scrolledwindow2, Policy_Always, Policy_Always);
      Pack_Start (Window1.Vbox9, Window1.Scrolledwindow2, True, True, 0);

      Gtk_New (Window1.Clist3, 5);
      Set_Selection_Mode (Window1.Clist3, Selection_Single);
      Set_Shadow_Type (Window1.Clist3, Shadow_In);
      Set_Show_Titles (Window1.Clist3, True);
      Set_Column_Width (Window1.Clist3, 0, 18);
      Set_Column_Width (Window1.Clist3, 1, 47);
      Set_Column_Width (Window1.Clist3, 2, 121);
      Set_Column_Width (Window1.Clist3, 3, 49);
      Set_Column_Width (Window1.Clist3, 4, 67);
      Set_Column_Width (Window1.Clist3, 3, 67);
      C_List_Callback.Connect
        (Window1.Clist3, "select_row", On_Clist3_Select_Row'Access);
      Add (Window1.Scrolledwindow2, Window1.Clist3);

      Gtk_New (Window1.LabelAdi1, "P#");
      Set_Alignment (Window1.LabelAdi1, 0.5, 0.5);
      Set_Padding (Window1.LabelAdi1, 0, 0);
      Set_Justify (Window1.LabelAdi1, Justify_Center);
      Set_Line_Wrap (Window1.LabelAdi1, False);
      Set_Column_Widget (Window1.Clist3, 0, Window1.LabelAdi1);

      Gtk_New (Window1.Label80, "Menge");
      Set_Alignment (Window1.Label80, 0.5, 0.5);
      Set_Padding (Window1.Label80, 0, 0);
      Set_Justify (Window1.Label80, Justify_Center);
      Set_Line_Wrap (Window1.Label80, False);
      Set_Column_Widget (Window1.Clist3, 1, Window1.Label80);

      Gtk_New (Window1.Label81, "Artikel");
      Set_Alignment (Window1.Label81, 0.5, 0.5);
      Set_Padding (Window1.Label81, 0, 0);
      Set_Justify (Window1.Label81, Justify_Center);
      Set_Line_Wrap (Window1.Label81, False);
      Set_Column_Widget (Window1.Clist3, 2, Window1.Label81);

      Gtk_New (Window1.Label82, "Epreis");
      Set_Alignment (Window1.Label82, 0.5, 0.5);
      Set_Padding (Window1.Label82, 0, 0);
      Set_Justify (Window1.Label82, Justify_Center);
      Set_Line_Wrap (Window1.Label82, False);
      Set_Column_Widget (Window1.Clist3, 3, Window1.Label82);

      Gtk_New (Window1.Label83, "Gpreis");
      Set_Alignment (Window1.Label83, 0.5, 0.5);
      Set_Padding (Window1.Label83, 0, 0);
      Set_Justify (Window1.Label83, Justify_Center);
      Set_Line_Wrap (Window1.Label83, False);
      Set_Column_Widget (Window1.Clist3, 4, Window1.Label83);

      Gtk_New (Window1.Table9, 1, 2, False);
      Set_Row_Spacings (Window1.Table9, 0);
      Set_Col_Spacings (Window1.Table9, 0);
      Pack_Start (Window1.Vbox9, Window1.Table9, False, True, 0);

      Gtk_New (Window1.Entry57);
      Set_Editable (Window1.Entry57, False);
      Set_Max_Length (Window1.Entry57, 0);
      Set_Text (Window1.Entry57, "");
      Set_Visibility (Window1.Entry57, True);
      Attach (Window1.Table9, Window1.Entry57, 1, 2, 0, 1,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Label92, "Total:");
      Set_Alignment (Window1.Label92, 0.98, 0.5);
      Set_Padding (Window1.Label92, 4, 2);
      Set_Justify (Window1.Label92, Justify_Center);
      Set_Line_Wrap (Window1.Label92, False);
      Attach (Window1.Table9, Window1.Label92, 0, 1, 0, 1,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Frame8, "Artikel modifizieren");
      Set_Shadow_Type (Window1.Frame8, Shadow_Etched_In);
      Pack_Start (Window1.Vbox9, Window1.Frame8, True, True, 10);

      Gtk_New (Window1.Table12, 4, 3, False);
      Set_Row_Spacings (Window1.Table12, 0);
      Set_Col_Spacings (Window1.Table12, 0);
      Add (Window1.Frame8, Window1.Table12);

      Gtk_New (Window1.Button27,  ("Ändern"));
      Set_Relief (Window1.Button27, Relief_Normal);
      Attach (Window1.Table12, Window1.Button27, 2, 3, 1, 2,
        Fill, 0,
        0, 0);
      Button_Callback.Connect
        (Window1.Button27, "clicked",
         Button_Callback.To_Marshaller (On_Change_Posten_Clicked'Access));

      Gtk_New (Window1.Button28a,  ("Löschen"));
      Set_Relief (Window1.Button28a, Relief_Normal);
      Attach (Window1.Table12, Window1.Button28a, 2, 3, 3, 4,
        Fill, 0,
        0, 0);
      Button_Callback.Connect
        (Window1.Button28a, "clicked",
         Button_Callback.To_Marshaller (On_Delete_Posten_Clicked'Access));

      Gtk_New (Window1.Label111a, "P#");
      Set_Alignment (Window1.Label111a, 0.0, 0.5);
      Set_Padding (Window1.Label111a, 4, 2);
      Set_Justify (Window1.Label111a, Justify_Center);
      Set_Line_Wrap (Window1.Label111a, False);
      Attach (Window1.Table12, Window1.Label111a, 0, 1, 0, 1,
        Fill, 0,
        0, 0);

      Gtk_New (Window1.Label112, "Menge");
      Set_Alignment (Window1.Label112, 0.0, 0.5);
      Set_Padding (Window1.Label112, 4, 2);
      Set_Justify (Window1.Label112, Justify_Center);
      Set_Line_Wrap (Window1.Label112, False);
      Attach (Window1.Table12, Window1.Label112, 0, 1, 1, 2,
        Fill, 0,
        0, 0);

      Gtk_New (Window1.Label113, "Artikel");
      Set_Alignment (Window1.Label113, 0.0, 0.5);
      Set_Padding (Window1.Label113, 4, 2);
      Set_Justify (Window1.Label113, Justify_Center);
      Set_Line_Wrap (Window1.Label113, False);
      Attach (Window1.Table12, Window1.Label113, 0, 1, 2, 3,
        Fill, 0,
        0, 0);

      Gtk_New (Window1.Label114, "Einzelpreis ");
      Set_Alignment (Window1.Label114, 0.0, 0.5);
      Set_Padding (Window1.Label114, 4, 2);
      Set_Justify (Window1.Label114, Justify_Center);
      Set_Line_Wrap (Window1.Label114, False);
      Attach (Window1.Table12, Window1.Label114, 0, 1, 3, 4,
        Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry67);
      Set_Editable (Window1.Entry67, True);
      Set_Max_Length (Window1.Entry67, 0);
      Set_Text (Window1.Entry67, "");
      Set_Visibility (Window1.Entry67, True);
      Attach (Window1.Table12, Window1.Entry67, 1, 2, 0, 1,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry68);
      Set_Editable (Window1.Entry68, True);
      Set_Max_Length (Window1.Entry68, 0);
      Set_Text (Window1.Entry68, "");
      Set_Visibility (Window1.Entry68, True);
      Attach (Window1.Table12, Window1.Entry68, 1, 2, 1, 2,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry69);
      Set_Editable (Window1.Entry69, True);
      Set_Max_Length (Window1.Entry69, 0);
      Set_Text (Window1.Entry69, "");
      Set_Visibility (Window1.Entry69, True);
      Attach (Window1.Table12, Window1.Entry69, 1, 2, 2, 3,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry70);
      Set_Editable (Window1.Entry70, True);
      Set_Max_Length (Window1.Entry70, 0);
      Set_Text (Window1.Entry70, "");
      Set_Visibility (Window1.Entry70, True);
      Attach (Window1.Table12, Window1.Entry70, 1, 2, 3, 4,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Table8, 5, 2, False);
      Set_Row_Spacings (Window1.Table8, 0);
      Set_Col_Spacings (Window1.Table8, 0);
      Pack_Start (Window1.Vbox9, Window1.Table8, False, False, 0);

      Gtk_New (Window1.Label88, "Name/Vorname");
      Set_Alignment (Window1.Label88, 0.0, 0.5);
      Set_Padding (Window1.Label88, 4, 2);
      Set_Justify (Window1.Label88, Justify_Center);
      Set_Line_Wrap (Window1.Label88, False);
      Attach (Window1.Table8, Window1.Label88, 0, 1, 0, 1,
        Fill, 0,
        0, 0);

      Gtk_New (Window1.Label89, "Firma");
      Set_Alignment (Window1.Label89, 0.0, 0.5);
      Set_Padding (Window1.Label89, 4, 2);
      Set_Justify (Window1.Label89, Justify_Center);
      Set_Line_Wrap (Window1.Label89, False);
      Attach (Window1.Table8, Window1.Label89, 0, 1, 1, 2,
        Fill, 0,
        0, 0);

      Gtk_New (Window1.Label90, "Ort");
      Set_Alignment (Window1.Label90, 0.0, 0.5);
      Set_Padding (Window1.Label90, 4, 2);
      Set_Justify (Window1.Label90, Justify_Center);
      Set_Line_Wrap (Window1.Label90, False);
      Attach (Window1.Table8, Window1.Label90, 0, 1, 3, 4,
        Fill, 0,
        0, 0);

      Gtk_New (Window1.Label90a, "Kunden-NR");
      Set_Alignment (Window1.Label90a, 0.0, 0.5);
      Set_Padding (Window1.Label90a, 4, 2);
      Set_Justify (Window1.Label90a, Justify_Center);
      Set_Line_Wrap (Window1.Label90a, False);
      Attach (Window1.Table8, Window1.Label90a, 0, 1, 4, 5,
        Fill, 0,
        0, 0);

      Gtk_New (Window1.Label91,  ("Straße"));
      Set_Alignment (Window1.Label91, 0.0, 0.5);
      Set_Padding (Window1.Label91, 4, 2);
      Set_Justify (Window1.Label91, Justify_Center);
      Set_Line_Wrap (Window1.Label91, False);
      Attach (Window1.Table8, Window1.Label91, 0, 1, 2, 3,
        Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry56);
      Set_Editable (Window1.Entry56, False);
      Set_Max_Length (Window1.Entry56, 0);
      Set_Text (Window1.Entry56, "");
      Set_Visibility (Window1.Entry56, True);
      Attach (Window1.Table8, Window1.Entry56, 1, 2, 3, 4,
        Expand or Fill, 0,
        4, 2);

      Gtk_New (Window1.Entry56a);
      Set_Editable (Window1.Entry56a, False);
      Set_Max_Length (Window1.Entry56a, 0);
      Set_Text (Window1.Entry56a, "");
      Set_Visibility (Window1.Entry56a, True);
      Attach (Window1.Table8, Window1.Entry56a, 1, 2, 4, 5,
        Expand or Fill, 0,
        4, 2);

      Gtk_New (Window1.Entry55);
      Set_Editable (Window1.Entry55, False);
      Set_Max_Length (Window1.Entry55, 0);
      Set_Text (Window1.Entry55, "");
      Set_Visibility (Window1.Entry55, True);
      Attach (Window1.Table8, Window1.Entry55, 1, 2, 2, 3,
        Expand or Fill, 0,
        4, 2);

      Gtk_New (Window1.Entry54);
      Set_Editable (Window1.Entry54, False);
      Set_Max_Length (Window1.Entry54, 0);
      Set_Text (Window1.Entry54, "");
      Set_Visibility (Window1.Entry54, True);
      Attach (Window1.Table8, Window1.Entry54, 1, 2, 1, 2,
        Expand or Fill, 0,
        4, 2);

      Gtk_New (Window1.Entry53);
      Set_Editable (Window1.Entry53, False);
      Set_Max_Length (Window1.Entry53, 0);
      Set_Text (Window1.Entry53, "");
      Set_Visibility (Window1.Entry53, True);
      Attach (Window1.Table8, Window1.Entry53, 1, 2, 0, 1,
        Expand or Fill, 0,
        4, 2);

      Gtk_New (Window1.Hbuttonbox6);
      Set_Spacing (Window1.Hbuttonbox6, 30);
      Set_Layout (Window1.Hbuttonbox6, Buttonbox_Spread);
      Set_Child_Size (Window1.Hbuttonbox6, 85, 27);
      Set_Child_Ipadding (Window1.Hbuttonbox6, 7, 0);
      Pack_Start (Window1.Vbox9, Window1.Hbuttonbox6, False, True, 0);

      Gtk_New (Window1.Button18, "Drucken");
      Set_Relief (Window1.Button18, Relief_Normal);
      Set_Flags (Window1.Button18, Can_Default);
      Button_Callback.Connect
        (Window1.Button18, "clicked",
         Button_Callback.To_Marshaller (On_Print_Clicked'Access));
      Add (Window1.Hbuttonbox6, Window1.Button18);

      Gtk_New (Window1.Label51,  ("Übersicht"));
      Set_Alignment (Window1.Label51, 0.5, 0.5);
      Set_Padding (Window1.Label51, 0, 0);
      Set_Justify (Window1.Label51, Justify_Center);
      Set_Line_Wrap (Window1.Label51, False);
      Set_Tab (Window1.Notebook3, 2, Window1.Label51);

      Gtk_New (Window1.Frame5);
      Set_Shadow_Type (Window1.Frame5, Shadow_Etched_In);
      Add (Window1.Notebook3, Window1.Frame5);

      Gtk_New_Vbox (Window1.Vbox10, False, 0);
      Add (Window1.Frame5, Window1.Vbox10);

      Gtk_New (Window1.Table10, 10, 2, False);
      Set_Row_Spacings (Window1.Table10, 0);
      Set_Col_Spacings (Window1.Table10, 0);
      Pack_Start (Window1.Vbox10, Window1.Table10, False, True, 0);

      Gtk_New (Window1.Label94, "Rechnungsnummer: ");
      Set_Alignment (Window1.Label94, 0.0, 0.5);
      Set_Padding (Window1.Label94, 4, 2);
      Set_Justify (Window1.Label94, Justify_Center);
      Set_Line_Wrap (Window1.Label94, False);
      Attach (Window1.Table10, Window1.Label94, 0, 1, 0, 1,
        Fill, 0,
        0, 0);

      Gtk_New (Window1.Label96, "Zahldatum:");
      Set_Alignment (Window1.Label96, 0.0, 0.5);
      Set_Padding (Window1.Label96, 4, 2);
      Set_Justify (Window1.Label96, Justify_Center);
      Set_Line_Wrap (Window1.Label96, False);
      Attach (Window1.Table10, Window1.Label96, 0, 1, 2, 3,
        Fill, 0,
        0, 0);

      Gtk_New (Window1.Label95, "Datum:");
      Set_Alignment (Window1.Label95, 0.0, 0.5);
      Set_Padding (Window1.Label95, 4, 2);
      Set_Justify (Window1.Label95, Justify_Center);
      Set_Line_Wrap (Window1.Label95, False);
      Attach (Window1.Table10, Window1.Label95, 0, 1, 1, 2,
        Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry60);
      Set_Editable (Window1.Entry60, True);
      Set_Max_Length (Window1.Entry60, 0);
      Set_Text (Window1.Entry60, "2000-12-24");
      Set_Visibility (Window1.Entry60, True);
      Attach (Window1.Table10, Window1.Entry60, 1, 2, 2, 3,
        Expand or Fill, 0,
        4, 2);

      Gtk_New (Window1.Entry59);
      Set_Editable (Window1.Entry59, True);
      Set_Max_Length (Window1.Entry59, 0);
      Set_Text (Window1.Entry59, "2000-12-24");
      Set_Visibility (Window1.Entry59, True);
      Attach (Window1.Table10, Window1.Entry59, 1, 2, 1, 2,
        Expand or Fill, 0,
        4, 2);

      Gtk_New (Window1.Entry58);
      Set_Editable (Window1.Entry58, True);
      Set_Max_Length (Window1.Entry58, 0);
      Set_Text (Window1.Entry58, "");
      Set_Visibility (Window1.Entry58, True);
      Attach (Window1.Table10, Window1.Entry58, 1, 2, 0, 1,
        Expand or Fill, 0,
        4, 2);

      Gtk_New_Hseparator (Window1.Hseparator4);
      Attach (Window1.Table10, Window1.Hseparator4, 1, 2, 3, 4,
        Fill, Fill,
        0, 0);

      Gtk_New_Hseparator (Window1.Hseparator5);
      Attach (Window1.Table10, Window1.Hseparator5, 0, 1, 3, 4,
        Fill, Fill,
        0, 0);

      Gtk_New (Window1.Label97, "Mitarbeiter:");
      Set_Alignment (Window1.Label97, 0.0, 0.5);
      Set_Padding (Window1.Label97, 4, 2);
      Set_Justify (Window1.Label97, Justify_Center);
      Set_Line_Wrap (Window1.Label97, False);
      Attach (Window1.Table10, Window1.Label97, 0, 1, 4, 5,
        Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry61);
      Set_Editable (Window1.Entry61, True);
      Set_Max_Length (Window1.Entry61, 0);
      Set_Text (Window1.Entry61, "");
      Set_Visibility (Window1.Entry61, True);
      Attach (Window1.Table10, Window1.Entry61, 1, 2, 4, 5,
        Expand or Fill, 0,
        4, 2);

      Gtk_New (Window1.Label98, "Status:");
      Set_Alignment (Window1.Label98, 0.0, 0.5);
      Set_Padding (Window1.Label98, 4, 2);
      Set_Justify (Window1.Label98, Justify_Center);
      Set_Line_Wrap (Window1.Label98, False);
      Attach (Window1.Table10, Window1.Label98, 0, 1, 5, 6,
        Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry62);
      Set_Editable (Window1.Entry62, True);
      Set_Max_Length (Window1.Entry62, 0);
      Set_Text (Window1.Entry62, "");
      Set_Visibility (Window1.Entry62, True);
      Attach (Window1.Table10, Window1.Entry62, 1, 2, 5, 6,
        Expand or Fill, 0,
        4, 2);

      Gtk_New (Window1.Label99, "Autom. Mahnung");
      Set_Alignment (Window1.Label99, 0.0, 0.5);
      Set_Padding (Window1.Label99, 4, 2);
      Set_Justify (Window1.Label99, Justify_Center);
      Set_Line_Wrap (Window1.Label99, False);
      Attach (Window1.Table10, Window1.Label99, 0, 1, 6, 7,
        Fill, 0,
        0, 0);

      Gtk_New_Hseparator (Window1.Hseparator6);
      Attach (Window1.Table10, Window1.Hseparator6, 0, 1, 7, 8,
        Fill, Expand or Fill,
        0, 0);

      Gtk_New_Hseparator (Window1.Hseparator7);
      Attach (Window1.Table10, Window1.Hseparator7, 1, 2, 7, 8,
        Fill, Fill,
        0, 0);

      Gtk_New (Window1.Label100, "Kommentar:");
      Set_Alignment (Window1.Label100, 0.0, 0.5);
      Set_Padding (Window1.Label100, 4, 2);
      Set_Justify (Window1.Label100, Justify_Center);
      Set_Line_Wrap (Window1.Label100, False);
      Attach (Window1.Table10, Window1.Label100, 0, 1, 8, 9,
        Fill, 0,
        0, 0);

      Gtk_New_Hseparator (Window1.Hseparator8);
      Attach (Window1.Table10, Window1.Hseparator8, 0, 1, 9, 10,
        Fill, Expand or Fill,
        0, 0);

      Gtk_New_Hseparator (Window1.Hseparator9);
      Attach (Window1.Table10, Window1.Hseparator9, 1, 2, 9, 10,
        Fill, Fill,
        0, 0);

      Gtk_New (Window1.Scrolledwindow3);
      Set_Policy (Window1.Scrolledwindow3, Policy_Never, Policy_Always);
      Attach (Window1.Table10, Window1.Scrolledwindow3, 1, 2, 8, 9,
        Fill, Fill,
        4, 2);

      Gtk_New (Window1.Text1);
      Set_Editable (Window1.Text1, True);
      Add (Window1.Scrolledwindow3, Window1.Text1);

      Gtk_New (Window1.Checkbutton1, "Diese Rechnung autom. mahnen");
      Set_Active (Window1.Checkbutton1, True);
      Attach (Window1.Table10, Window1.Checkbutton1, 1, 2, 6, 7,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Hbuttonbox7);
      Set_Spacing (Window1.Hbuttonbox7, 30);
      Set_Layout (Window1.Hbuttonbox7, Buttonbox_Spread);
      Set_Child_Size (Window1.Hbuttonbox7, 85, 27);
      Set_Child_Ipadding (Window1.Hbuttonbox7, 7, 0);
      Pack_Start (Window1.Vbox10, Window1.Hbuttonbox7, True, False, 0);

      Gtk_New (Window1.Button19, "Setzen");
      Set_Relief (Window1.Button19, Relief_Normal);
      Set_Flags (Window1.Button19, Can_Default);
      Button_Callback.Connect
        (Window1.Button19, "clicked",
         Button_Callback.To_Marshaller (On_Setbilldetails_Clicked'Access));
      Add (Window1.Hbuttonbox7, Window1.Button19);

      Gtk_New (Window1.Button20, "Show/Reset");
      Set_Relief (Window1.Button20, Relief_Normal);
      Set_Flags (Window1.Button20, Can_Default);
      Button_Callback.Connect
        (Window1.Button20, "clicked",
         Button_Callback.To_Marshaller (On_Billdetailsreset_Clicked'Access));
      Add (Window1.Hbuttonbox7, Window1.Button20);

      Gtk_New (Window1.Label93, "Details");
      Set_Alignment (Window1.Label93, 0.5, 0.5);
      Set_Padding (Window1.Label93, 0, 0);
      Set_Justify (Window1.Label93, Justify_Center);
      Set_Line_Wrap (Window1.Label93, False);
      Set_Tab (Window1.Notebook3, 3, Window1.Label93);

      Gtk_New (Window1.Frame6);
      Set_Shadow_Type (Window1.Frame6, Shadow_Etched_In);
      Add (Window1.Notebook3, Window1.Frame6);

      Gtk_New_Vbox (Window1.Vbox11, False, 0);
      Add (Window1.Frame6, Window1.Vbox11);

      Gtk_New (Window1.Table11, 3, 2, False);
      Set_Row_Spacings (Window1.Table11, 0);
      Set_Col_Spacings (Window1.Table11, 0);
      Pack_Start (Window1.Vbox11, Window1.Table11, False, True, 0);

      Gtk_New (Window1.Entry63);
      Set_Editable (Window1.Entry63, True);
      Set_Max_Length (Window1.Entry63, 0);
      Set_Text (Window1.Entry63, "");
      Set_Visibility (Window1.Entry63, True);
      Attach (Window1.Table11, Window1.Entry63, 1, 2, 0, 1,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry64);
      Set_Editable (Window1.Entry64, True);
      Set_Max_Length (Window1.Entry64, 0);
      Set_Text (Window1.Entry64, "");
      Set_Visibility (Window1.Entry64, True);
      Attach (Window1.Table11, Window1.Entry64, 1, 2, 1, 2,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry65);
      Set_Editable (Window1.Entry65, True);
      Set_Max_Length (Window1.Entry65, 0);
      Set_Text (Window1.Entry65, "");
      Set_Visibility (Window1.Entry65, True);
      Attach (Window1.Table11, Window1.Entry65, 1, 2, 2, 3,
        Expand or Fill, 0,
        0, 0);

      Gtk_New (Window1.Label102, "Kundennummer");
      Set_Alignment (Window1.Label102, 0.0, 0.5);
      Set_Padding (Window1.Label102, 0, 0);
      Set_Justify (Window1.Label102, Justify_Center);
      Set_Line_Wrap (Window1.Label102, False);
      Attach (Window1.Table11, Window1.Label102, 0, 1, 0, 1,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Label103, "Vorname");
      Set_Alignment (Window1.Label103, 0.0, 0.5);
      Set_Padding (Window1.Label103, 0, 0);
      Set_Justify (Window1.Label103, Justify_Center);
      Set_Line_Wrap (Window1.Label103, False);
      Attach (Window1.Table11, Window1.Label103, 0, 1, 1, 2,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Label104, "Name");
      Set_Alignment (Window1.Label104, 0.0, 0.5);
      Set_Padding (Window1.Label104, 0, 0);
      Set_Justify (Window1.Label104, Justify_Left);
      Set_Line_Wrap (Window1.Label104, False);
      Attach (Window1.Table11, Window1.Label104, 0, 1, 2, 3,
        Fill, 0,
        4, 2);

      Gtk_New (Window1.Button21,  ("Rechnungen für Kunden " &
                                                 "anzeigen"));
      Set_Relief (Window1.Button21, Relief_Normal);
      Pack_Start (Window1.Vbox11, Window1.Button21, False, False, 0);
      Button_Callback.Connect
        (Window1.Button21, "clicked",
         Button_Callback.To_Marshaller (On_Search_Bill'Access));

      Gtk_New (Window1.Scrolledwindow4);
      Set_Policy (Window1.Scrolledwindow4, Policy_Always, Policy_Always);
      Pack_Start (Window1.Vbox11, Window1.Scrolledwindow4, True, True, 0);

      Gtk_New (Window1.Clist4, 3);
      Set_Selection_Mode (Window1.Clist4, Selection_Single);
      Set_Shadow_Type (Window1.Clist4, Shadow_In);
      Set_Show_Titles (Window1.Clist4, True);
      Set_Column_Width (Window1.Clist4, 0, 80);
      Set_Column_Width (Window1.Clist4, 1, 80);
      Set_Column_Width (Window1.Clist4, 2, 80);
      C_List_Callback.Connect
        (Window1.Clist4, "select_row", On_Clist4_Select_Row'Access);
      C_List_Callback.Connect
        (Window1.Clist4, "click_column", Sortmode_Change'Access);
      Add (Window1.Scrolledwindow4, Window1.Clist4);

      Gtk_New (Window1.Label105, "Rech-#");
      Set_Alignment (Window1.Label105, 0.5, 0.5);
      Set_Padding (Window1.Label105, 0, 0);
      Set_Justify (Window1.Label105, Justify_Center);
      Set_Line_Wrap (Window1.Label105, False);
      Set_Column_Widget (Window1.Clist4, 0, Window1.Label105);

      Gtk_New (Window1.Label106, "Datum");
      Set_Alignment (Window1.Label106, 0.5, 0.5);
      Set_Padding (Window1.Label106, 0, 0);
      Set_Justify (Window1.Label106, Justify_Center);
      Set_Line_Wrap (Window1.Label106, False);
      Set_Column_Widget (Window1.Clist4, 1, Window1.Label106);

      Gtk_New (Window1.Label107, "Kommentar");
      Set_Alignment (Window1.Label107, 0.5, 0.5);
      Set_Padding (Window1.Label107, 0, 0);
      Set_Justify (Window1.Label107, Justify_Center);
      Set_Line_Wrap (Window1.Label107, False);
      Set_Column_Widget (Window1.Clist4, 2, Window1.Label107);

      Gtk_New (Window1.Label101, "Suchen");
      Set_Alignment (Window1.Label101, 0.5, 0.5);
      Set_Padding (Window1.Label101, 0, 0);
      Set_Justify (Window1.Label101, Justify_Center);
      Set_Line_Wrap (Window1.Label101, False);
      Set_Tab (Window1.Notebook3, 4, Window1.Label101);

      Gtk_New (Window1.Label2, "Rechnung");
      Set_Alignment (Window1.Label2, 0.5, 0.5);
      Set_Padding (Window1.Label2, 0, 0);
      Set_Justify (Window1.Label2, Justify_Center);
      Set_Line_Wrap (Window1.Label2, False);
      Set_Tab (Window1.Notebook1, 1, Window1.Label2);

      Gtk_New (Window1.Frame2);
      Set_Shadow_Type (Window1.Frame2, Shadow_Etched_In);
      Add (Window1.Notebook1, Window1.Frame2);

      Gtk_New (Window1.Notebook4);
      Set_Scrollable (Window1.Notebook4, False);
      Set_Show_Border (Window1.Notebook4, True);
      Set_Show_Tabs (Window1.Notebook4, True);
      Set_Tab_Hborder (Window1.Notebook4, 2);
      Set_Tab_Vborder (Window1.Notebook4, 2);
      Set_Tab_Pos (Window1.Notebook4, Pos_Top);
      Add (Window1.Frame2, Window1.Notebook4);

      Gtk_New_Vbox (Window1.Vbox8, False, 0);
      Add (Window1.Notebook4, Window1.Vbox8);

      Gtk_New (Window1.Scrolledwindow1);
      Set_Policy (Window1.Scrolledwindow1, Policy_Always, Policy_Always);
      Pack_Start (Window1.Vbox8, Window1.Scrolledwindow1, True, True, 0);

      Gtk_New (Window1.Clist2, 2);
      Set_Selection_Mode (Window1.Clist2, Selection_Single);
      Set_Shadow_Type (Window1.Clist2, Shadow_In);
      Set_Show_Titles (Window1.Clist2, True);
      Set_Column_Width (Window1.Clist2, 0, 47);
      Set_Column_Width (Window1.Clist2, 1, 80);
      Set_Events (Window1.Clist2,
        Button_Press_Mask);
      Add (Window1.Scrolledwindow1, Window1.Clist2);

      Gtk_New (Window1.Label76,  ("Priorität"));
      Set_Alignment (Window1.Label76, 0.5, 0.5);
      Set_Padding (Window1.Label76, 0, 0);
      Set_Justify (Window1.Label76, Justify_Center);
      Set_Line_Wrap (Window1.Label76, False);
      Set_Column_Widget (Window1.Clist2, 0, Window1.Label76);

      Gtk_New (Window1.Label77, "What");
      Set_Alignment (Window1.Label77, 0.5, 0.5);
      Set_Padding (Window1.Label77, 0, 0);
      Set_Justify (Window1.Label77, Justify_Center);
      Set_Line_Wrap (Window1.Label77, False);
      Set_Column_Widget (Window1.Clist2, 1, Window1.Label77);

      Gtk_New (Window1.Hbuttonbox5);
      Set_Spacing (Window1.Hbuttonbox5, 30);
      Set_Layout (Window1.Hbuttonbox5, Buttonbox_Start);
      Set_Child_Size (Window1.Hbuttonbox5, 85, 27);
      Set_Child_Ipadding (Window1.Hbuttonbox5, 7, 0);
      Pack_Start (Window1.Vbox8, Window1.Hbuttonbox5, True, True, 0);

      Gtk_New (Window1.Button13,  ("Löschen"));
      Set_Relief (Window1.Button13, Relief_Normal);
      Set_Flags (Window1.Button13, Can_Default);
      Button_Callback.Connect
        (Window1.Button13, "clicked",
         Button_Callback.To_Marshaller (On_Delete_Todo_Row_Clicked'Access));
      Add (Window1.Hbuttonbox5, Window1.Button13);

      Gtk_New (Window1.Button14, "Reload");
      Set_Relief (Window1.Button14, Relief_Normal);
      Set_Flags (Window1.Button14, Can_Default);
      Button_Callback.Connect
        (Window1.Button14, "clicked",
         Button_Callback.To_Marshaller (On_Reload_Todo'Access));
      Add (Window1.Hbuttonbox5, Window1.Button14);

      Gtk_New (Window1.Button15, "Priority");
      Set_Relief (Window1.Button15, Relief_Normal);
      Set_Flags (Window1.Button15, Can_Default);
      Button_Callback.Connect
        (Window1.Button15, "clicked",
         Button_Callback.To_Marshaller (On_Change_Priority'Access));
      Add (Window1.Hbuttonbox5, Window1.Button15);

      Gtk_New (Window1.Label67, "Neuer Eintrag:");
      Set_Alignment (Window1.Label67, 0.5, 0.5);
      Set_Padding (Window1.Label67, 0, 0);
      Set_Justify (Window1.Label67, Justify_Center);
      Set_Line_Wrap (Window1.Label67, False);
      Pack_Start (Window1.Vbox8, Window1.Label67, False, False, 0);

      Gtk_New (Window1.Table7, 2, 2, False);
      Set_Row_Spacings (Window1.Table7, 0);
      Set_Col_Spacings (Window1.Table7, 0);
      Pack_Start (Window1.Vbox8, Window1.Table7, True, True, 0);

      Gtk_New (Window1.Label68, "Eintrag");
      Set_Alignment (Window1.Label68, 0.0, 0.5);
      Set_Padding (Window1.Label68, 4, 2);
      Set_Justify (Window1.Label68, Justify_Center);
      Set_Line_Wrap (Window1.Label68, False);
      Attach (Window1.Table7, Window1.Label68, 0, 1, 0, 1,
        Fill, 0,
        0, 0);

      Gtk_New (Window1.Label69,  ("Priorität"));
      Set_Alignment (Window1.Label69, 0.0, 0.5);
      Set_Padding (Window1.Label69, 4, 2);
      Set_Justify (Window1.Label69, Justify_Center);
      Set_Line_Wrap (Window1.Label69, False);
      Attach (Window1.Table7, Window1.Label69, 0, 1, 1, 2,
        Fill, 0,
        0, 0);

      Gtk_New (Window1.Entry46);
      Set_Editable (Window1.Entry46, True);
      Set_Max_Length (Window1.Entry46, 0);
      Set_Text (Window1.Entry46, "");
      Set_Visibility (Window1.Entry46, True);
      Attach (Window1.Table7, Window1.Entry46, 1, 2, 0, 1,
        Expand or Fill, 0,
        4, 2);

      Gtk_New (Window1.Combo1);
      Set_Case_Sensitive (Window1.Combo1, False);
      Set_Use_Arrows (Window1.Combo1, True);
      Set_Use_Arrows_Always (Window1.Combo1, True);
      String_List.Append (Combo1_Items, "Normal");
      String_List.Append (Combo1_Items, "Mittel");
      String_List.Append (Combo1_Items, "Hoch");
      Combo.Set_Popdown_Strings (Window1.Combo1, Combo1_Items);
      Free_String_List (Combo1_Items);
      Attach (Window1.Table7, Window1.Combo1, 1, 2, 1, 2,
        Expand or Fill, 0,
        4, 2);

      Window1.Combo_Entry1 := Gtk_Entry (Get_Entry (Window1.Combo1));
      Set_Editable (Window1.Combo_Entry1, True);
      Set_Max_Length (Window1.Combo_Entry1, 0);
      Set_Text (Window1.Combo_Entry1, "Normal");
      Set_Visibility (Window1.Combo_Entry1, True);

      Gtk_New (Window1.Button11, "Eintrag speichern");
      Set_Relief (Window1.Button11, Relief_Normal);
      Pack_Start (Window1.Vbox8, Window1.Button11, True, False, 0);
      Button_Callback.Connect
        (Window1.Button11, "clicked",
         Button_Callback.To_Marshaller (On_Todo_Insert_Clicked'Access));

      Gtk_New (Window1.Label61, "Todo-List");
      Set_Alignment (Window1.Label61, 0.5, 0.5);
      Set_Padding (Window1.Label61, 0, 0);
      Set_Justify (Window1.Label61, Justify_Center);
      Set_Line_Wrap (Window1.Label61, False);
      Set_Tab (Window1.Notebook4, 0, Window1.Label61);
      Label_Callback.Connect
        (Window1.Label61, "show",
         Label_Callback.To_Marshaller (On_Todo_Called_Show'Access));

      Gtk_New (Window1.Frame7, "Run System-Commands");
      Set_Shadow_Type (Window1.Frame7, Shadow_Etched_In);
      Add (Window1.Notebook4, Window1.Frame7);

      Gtk_New (Window1.Vbuttonbox1);
      Set_Spacing (Window1.Vbuttonbox1, 10);
      Set_Layout (Window1.Vbuttonbox1, Buttonbox_Spread);
      Set_Child_Size (Window1.Vbuttonbox1, 85, 27);
      Set_Child_Ipadding (Window1.Vbuttonbox1, 7, 0);
      Add (Window1.Frame7, Window1.Vbuttonbox1);

      Gtk_New (Window1.Button22, "Write Email (mutt)");
      Set_Relief (Window1.Button22, Relief_Normal);
      Set_Flags (Window1.Button22, Can_Default);
      Add_Accelerator (Window1.Button22, "clicked",
        The_Accel_Group, GDK_M, Gdk.Types.Mod1_Mask, Accel_Visible);
      Button_Callback.Connect
        (Window1.Button22, "clicked",
         Button_Callback.To_Marshaller (On_Write_Mail'Access));
      Add (Window1.Vbuttonbox1, Window1.Button22);

      Gtk_New (Window1.Button23, "Browse the web (Netscape)");
      Set_Relief (Window1.Button23, Relief_Normal);
      Set_Flags (Window1.Button23, Can_Default);
      Add_Accelerator (Window1.Button23, "clicked",
        The_Accel_Group, GDK_W, Gdk.Types.Mod1_Mask, Accel_Visible);
      Button_Callback.Connect
        (Window1.Button23, "clicked",
         Button_Callback.To_Marshaller (On_Browse_Web'Access));
      Add (Window1.Vbuttonbox1, Window1.Button23);

      Gtk_New (Window1.Button24, "Read News (tin)");
      Set_Relief (Window1.Button24, Relief_Normal);
      Set_Flags (Window1.Button24, Can_Default);
      Add_Accelerator (Window1.Button24, "clicked",
        The_Accel_Group, GDK_N, Gdk.Types.Mod1_Mask, Accel_Visible);
      Button_Callback.Connect
        (Window1.Button24, "clicked",
         Button_Callback.To_Marshaller (On_Read_News'Access));
      Add (Window1.Vbuttonbox1, Window1.Button24);

      Gtk_New (Window1.Label62, "System");
      Set_Alignment (Window1.Label62, 0.5, 0.5);
      Set_Padding (Window1.Label62, 0, 0);
      Set_Justify (Window1.Label62, Justify_Center);
      Set_Line_Wrap (Window1.Label62, False);
      Set_Tab (Window1.Notebook4, 1, Window1.Label62);

      Gtk_New_Vbox (Window1.Vbox12, False, 0);
      Add (Window1.Notebook4, Window1.Vbox12);

      Gtk_New (Window1.Scrolledwindow5);
      Set_Policy (Window1.Scrolledwindow5, Policy_Never, Policy_Always);
      Pack_Start (Window1.Vbox12, Window1.Scrolledwindow5, True, True, 0);

      Gtk_New (Window1.Text2);
      Set_Editable (Window1.Text2, False);
      Add (Window1.Scrolledwindow5, Window1.Text2);

      Gtk_New_Hbox (Window1.Hbox4, False, 0);
      Pack_Start (Window1.Vbox12, Window1.Hbox4, False, False, 0);

      Gtk_New (Window1.Entry66);
      Set_Editable (Window1.Entry66, True);
      Set_Max_Length (Window1.Entry66, 0);
      Set_Text (Window1.Entry66, "");
      Set_Visibility (Window1.Entry66, True);
      Pack_Start (Window1.Hbox4, Window1.Entry66, True, True, 4);

      Gtk_New (Window1.Button25, "Do SQL!");
      Set_Relief (Window1.Button25, Relief_Normal);
      Pack_Start (Window1.Hbox4, Window1.Button25, False, False, 4);
      Button_Callback.Connect
        (Window1.Button25, "clicked",
         Button_Callback.To_Marshaller (On_Misc_Sql_Clicked'Access));

      Gtk_New (Window1.Label63, "SQL-Window");
      Set_Alignment (Window1.Label63, 0.5, 0.5);
      Set_Padding (Window1.Label63, 0, 0);
      Set_Justify (Window1.Label63, Justify_Center);
      Set_Line_Wrap (Window1.Label63, False);
      Set_Tab (Window1.Notebook4, 2, Window1.Label63);

      Gtk_New (Window1.Label3, "Irgendwas");
      Set_Alignment (Window1.Label3, 0.5, 0.5);
      Set_Padding (Window1.Label3, 0, 0);
      Set_Justify (Window1.Label3, Justify_Center);
      Set_Line_Wrap (Window1.Label3, False);
      Set_Tab (Window1.Notebook1, 2, Window1.Label3);

      Gtk_New (Window1.Statusbar1);
      Set_Border_Width (Window1.Statusbar1, 2);
      Pack_Start (Window1.Vbox1, Window1.Statusbar1, False, False, 0);

      --  closing via windowmanager
      Window_Callback.Connect
        (Window1, "destroy",
         Window_Callback.To_Marshaller (on_window1_destroy'Access));

   end Initialize;

end Window1_Pkg;
